Bug 19431

Summary: Deadlock between fflush, getdelim, and fork
Product: glibc Reporter: Florian Weimer <fweimer>
Component: mallocAssignee: Florian Weimer <fweimer>
Status: RESOLVED FIXED    
Severity: normal CC: prumpf
Priority: P2 Flags: fweimer: security-
Version: 2.23   
Target Milestone: 2.24   
See Also: https://bugzilla.redhat.com/show_bug.cgi?id=906468
https://sourceware.org/bugzilla/show_bug.cgi?id=16742
Host: Target:
Build: Last reconfirmed:
Attachments: tst-malloc-fork-io.c

Description Florian Weimer 2016-01-05 16:44:14 UTC
Created attachment 8881 [details]
tst-malloc-fork-io.c

The attached test case, based on a downstream bug report, exhibits a three-way deadlock between fflush (NULL), getdelim, and fork.

We should remove the fork handler and replace it with explicit calls into the malloc code from within fork, *after* acquiring the libio lock.  This would like address bug 16742 as well.
Comment 1 prumpf 2016-01-05 17:51:09 UTC
Would that lose us the ability to use external malloc() implementations based on our default malloc()?

I'm not happy with the rather complicated fix at bug 16742, which introduces atfork handler priorities, but IIRC providing an API for external malloc()s rather than explicitly calling into the malloc code from within fork was part of the reason.  I'm not objecting to your solution at all, but I think we should make it clear in the documentation if the internal malloc() implementation becomes the only malloc() it is safe to use during fork()s.

Thanks for looking into this!
Comment 2 Florian Weimer 2016-01-05 17:57:44 UTC
(In reply to prumpf from comment #1)
> Would that lose us the ability to use external malloc() implementations
> based on our default malloc()?

No, not directly.  It will not fix the bug for external mallocs, but they might not even have these bugs, or support malloc after multi-threaded fork at all (which is a glibc extension).

> I'm not happy with the rather complicated fix at bug 16742, which introduces
> atfork handler priorities, but IIRC providing an API for external malloc()s
> rather than explicitly calling into the malloc code from within fork was
> part of the reason.  I'm not objecting to your solution at all, but I think
> we should make it clear in the documentation if the internal malloc()
> implementation becomes the only malloc() it is safe to use during fork()s.

I think this is entirely up to the interposed malloc implementation and what they want to support.
Comment 3 cvs-commit@gcc.gnu.org 2016-04-14 07:43:33 UTC
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, master has been updated
       via  29d794863cd6e03115d3670707cc873a9965ba92 (commit)
      from  b49ab5f4503f36dcbf43f821f817da66b2931fe6 (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=29d794863cd6e03115d3670707cc873a9965ba92

commit 29d794863cd6e03115d3670707cc873a9965ba92
Author: Florian Weimer <fweimer@redhat.com>
Date:   Thu Apr 14 09:17:02 2016 +0200

    malloc: Run fork handler as late as possible [BZ #19431]
    
    Previously, a thread M invoking fork would acquire locks in this order:
    
      (M1) malloc arena locks (in the registered fork handler)
      (M2) libio list lock
    
    A thread F invoking flush (NULL) would acquire locks in this order:
    
      (F1) libio list lock
      (F2) individual _IO_FILE locks
    
    A thread G running getdelim would use this order:
    
      (G1) _IO_FILE lock
      (G2) malloc arena lock
    
    After executing (M1), (F1), (G1), none of the threads can make progress.
    
    This commit changes the fork lock order to:
    
      (M'1) libio list lock
      (M'2) malloc arena locks
    
    It explicitly encodes the lock order in the implementations of fork,
    and does not rely on the registration order, thus avoiding the deadlock.

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog                                          |   24 ++
 malloc/Makefile                                    |    3 +-
 malloc/arena.c                                     |   58 ++----
 .../timer_getoverr.c => malloc/malloc-internal.h   |   30 +--
 malloc/malloc.c                                    |    1 +
 malloc/tst-malloc-fork-deadlock.c                  |  220 ++++++++++++++++++++
 manual/memory.texi                                 |    8 -
 sysdeps/mach/hurd/fork.c                           |   13 ++
 sysdeps/nptl/fork.c                                |   13 +-
 9 files changed, 300 insertions(+), 70 deletions(-)
 copy sysdeps/unix/sysv/linux/timer_getoverr.c => malloc/malloc-internal.h (57%)
 create mode 100644 malloc/tst-malloc-fork-deadlock.c
Comment 4 Florian Weimer 2016-04-14 08:01:02 UTC
Fixed in 2.24.
Comment 5 cvs-commit@gcc.gnu.org 2016-05-09 09:23:42 UTC
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, release/2.23/master has been updated
       via  888d9a0146b4b8364e065ab359eae5b3db5badb9 (commit)
       via  927170dd59787d9443e07eeb0b22329c4eff1530 (commit)
       via  2a71cf409681b89ffb8892b35cac64de79b7adb8 (commit)
       via  a5c2f42566460fc73755c768e8e1c59dbd5a4bb2 (commit)
       via  f69ae17e843b00d3495b736f4381c1fa64dc02bc (commit)
      from  4c4b3cbb4638ec19de19c167d498e30fd67501ab (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=888d9a0146b4b8364e065ab359eae5b3db5badb9

commit 888d9a0146b4b8364e065ab359eae5b3db5badb9
Author: Florian Weimer <fweimer@redhat.com>
Date:   Thu Apr 14 12:53:03 2016 +0200

    malloc: Add missing internal_function attributes on function definitions
    
    Fixes build on i386 after commit 29d794863cd6e03115d3670707cc873a9965ba92.
    
    (cherry picked from commit 186fe877f3df0b84d57dfbf0386f6332c6aa69bc)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=927170dd59787d9443e07eeb0b22329c4eff1530

commit 927170dd59787d9443e07eeb0b22329c4eff1530
Author: Florian Weimer <fweimer@redhat.com>
Date:   Thu Apr 14 09:18:30 2016 +0200

    malloc: Remove malloc hooks from fork handler
    
    The fork handler now runs so late that there is no risk anymore that
    other fork handlers in the same thread use malloc, so it is no
    longer necessary to install malloc hooks which made a subset
    of malloc functionality available to the thread that called fork.
    
    (cherry picked from commit 8a727af925be63aa6ea0f5f90e16751fd541626b)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=2a71cf409681b89ffb8892b35cac64de79b7adb8

commit 2a71cf409681b89ffb8892b35cac64de79b7adb8
Author: Florian Weimer <fweimer@redhat.com>
Date:   Thu Apr 14 09:17:02 2016 +0200

    malloc: Run fork handler as late as possible [BZ #19431]
    
    Previously, a thread M invoking fork would acquire locks in this order:
    
      (M1) malloc arena locks (in the registered fork handler)
      (M2) libio list lock
    
    A thread F invoking flush (NULL) would acquire locks in this order:
    
      (F1) libio list lock
      (F2) individual _IO_FILE locks
    
    A thread G running getdelim would use this order:
    
      (G1) _IO_FILE lock
      (G2) malloc arena lock
    
    After executing (M1), (F1), (G1), none of the threads can make progress.
    
    This commit changes the fork lock order to:
    
      (M'1) libio list lock
      (M'2) malloc arena locks
    
    It explicitly encodes the lock order in the implementations of fork,
    and does not rely on the registration order, thus avoiding the deadlock.
    
    (cherry picked from commit 29d794863cd6e03115d3670707cc873a9965ba92)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=a5c2f42566460fc73755c768e8e1c59dbd5a4bb2

commit a5c2f42566460fc73755c768e8e1c59dbd5a4bb2
Author: Samuel Thibault <samuel.thibault@ens-lyon.org>
Date:   Tue Mar 22 09:58:48 2016 +0100

    Fix malloc threaded tests link on non-Linux
    
    	* malloc/Makefile ($(objpfx)tst-malloc-backtrace,
    	$(objpfx)tst-malloc-thread-exit, $(objpfx)tst-malloc-thread-fail): Use
    	$(shared-thread-library) instead of hardcoding the path to libpthread.
    
    (cherry picked from commit b87e41378beca3c98ec3464d64835e66cc788497)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=f69ae17e843b00d3495b736f4381c1fa64dc02bc

commit f69ae17e843b00d3495b736f4381c1fa64dc02bc
Author: Florian Weimer <fweimer@redhat.com>
Date:   Fri Feb 19 17:07:45 2016 +0100

    malloc: Remove NO_THREADS
    
    No functional change.  It was not possible to build without
    threading support before.
    
    (cherry picked from commit 59eda029a8a35e5f4e5cd7be0f84c6629e48ec6e)

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog                                          |   60 ++++++
 malloc/Makefile                                    |   12 +-
 malloc/arena.c                                     |  183 +++--------------
 .../timer_getoverr.c => malloc/malloc-internal.h   |   30 +--
 malloc/malloc.c                                    |    5 +-
 malloc/tst-malloc-fork-deadlock.c                  |  220 ++++++++++++++++++++
 manual/memory.texi                                 |    8 -
 sysdeps/generic/malloc-machine.h                   |   19 --
 sysdeps/mach/hurd/fork.c                           |   13 ++
 sysdeps/nptl/fork.c                                |   13 +-
 10 files changed, 347 insertions(+), 216 deletions(-)
 copy sysdeps/unix/sysv/linux/timer_getoverr.c => malloc/malloc-internal.h (57%)
 create mode 100644 malloc/tst-malloc-fork-deadlock.c
Comment 6 cvs-commit@gcc.gnu.org 2016-08-02 02:55:33 UTC
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The annotated tag, glibc-2.24 has been created
        at  beb0f59498c3e0337df298f9d7a3f8f77eb39842 (tag)
   tagging  fdfc9260b61d3d72541f18104d24c7bcb0ce5ca2 (commit)
  replaces  glibc-2.23
 tagged by  Carlos O'Donell
        on  Mon Aug 1 22:46:26 2016 -0400

- Log -----------------------------------------------------------------
The GNU C Library
=================

The GNU C Library version 2.24 is now available.

The GNU C Library is used as *the* C library in the GNU system and
in GNU/Linux systems, as well as many other systems that use Linux
as the kernel.

The GNU C Library is primarily designed to be a portable
and high performance C library.  It follows all relevant
standards including ISO C11 and POSIX.1-2008.  It is also
internationalized and has one of the most complete
internationalization interfaces known.

The GNU C Library webpage is at http://www.gnu.org/software/libc/

Packages for the 2.24 release may be downloaded from:
        http://ftpmirror.gnu.org/libc/
        http://ftp.gnu.org/gnu/libc/

The mirror list is at http://www.gnu.org/order/ftp.html

NEWS for version 2.24
=====================

* The minimum Linux kernel version that this version of the GNU C Library
  can be used with is 3.2, except on i[4567]86 and x86_64, where Linux
  kernel version 2.6.32 or later suffices (on architectures that already
  required kernel versions more recent than 3.2, those requirements remain
  unchanged).  Linux 3.2 or later kernel headers are required on all
  architectures.

* The pap_AN locale has been deleted.  This has been deprecated for a long
  time.  It has been replaced by pap_AW & pap_CW, both of which have long
  been included in previous releases.

* The readdir_r and readdir64_r functions have been deprecated.  It is
  recommended to use readdir and readdir64 instead.

* The type “union wait” has been removed.  It was deprecated in the early
  1990s and never part of POSIX.  Application code should use the int type
  instead of “union wait”.

* A new NSS action is added to facilitate large distributed system
  administration.  The action, MERGE, allows remote user stores like LDAP
  to be merged into local user stores like /etc/groups in order to provide
  easy to use, updated, and managed sets of merged credentials.  The new
  action can be used by configuring it in /etc/nsswitch.conf:
  group: files [SUCCESS=merge] nis
  Implemented by Stephen Gallagher (Red Hat).

* The deprecated __malloc_initialize_hook variable has been removed from the
  API.

* The long unused localedef --old-style option has been removed.  It hasn't
  done anything in over 16 years.  Scripts using this option can safely
  drop it.

* nextupl, nextup, nextupf, nextdownl, nextdown and nextdownf are added to
  libm.  They are defined by TS 18661 and IEEE754-2008.  The nextup functions
  return the next representable value in the direction of positive infinity
  and the nextdown functions return the next representable value in the
  direction of negative infinity.  These are currently enabled as GNU
  extensions.

Security related changes:

* An unnecessary stack copy in _nss_dns_getnetbyname_r was removed.  It
  could result in a stack overflow when getnetbyname was called with an
  overly long name.  (CVE-2016-3075)

* Previously, getaddrinfo copied large amounts of address data to the stack,
  even after the fix for CVE-2013-4458 has been applied, potentially
  resulting in a stack overflow.  getaddrinfo now uses a heap allocation
  instead.  Reported by Michael Petlan.  (CVE-2016-3706)

* The glob function suffered from a stack-based buffer overflow when it was
  called with the GLOB_ALTDIRFUNC flag and encountered a long file name.
  Reported by Alexander Cherepanov.  (CVE-2016-1234)

* The Sun RPC UDP client could exhaust all available stack space when
  flooded with crafted ICMP and UDP messages.  Reported by Aldy Hernandez'
  alloca plugin for GCC.  (CVE-2016-4429)

* The IPv6 name server management code in libresolv could result in a memory
  leak for each thread which is created, performs a failing naming lookup,
  and exits.  Over time, this could result in a denial of service due to
  memory exhaustion.  Reported by Matthias Schiffer.  (CVE-2016-5417)

The following bugs are resolved with this release:

  [1170] localedata: ne_NP: update Nepali locale definition file
  [3629] manual: stpcpy description in string.texi refers to MS-DOG instead
    of MS-DOS.
  [6527] malloc: [powerpc] Malloc alignment insufficient for PowerPC
  [6796] math: fdim() does not set errno on overflow
  [10354] libc: posix_spawn should use vfork() in more cases than presently
  [11213] localedata: localedata: add copyright disclaimer to locale files
  [12143] localedata: chr_US: new Cherokee locale
  [12450] localedata: sgs_LT: new locale
  [12676] localedata: ln_CD: new locale
  [13237] localedata: LC_ADDRESS.country_name: update all locales w/latest
    CLDR data
  [13304] math: fma, fmaf, fmal produce wrong results
  [14259] build: --localedir arg to configure is ignored
  [14499] nptl: Does posix_spawn invoke atfork handlers / use vfork?
  [14750] libc: Race condition in posix_spawn vfork usage vs signal handlers
  [14934] localedata: es_CL: wrong first weekday chilean locale
  [15262] localedata: LC_MESSAGES.yesexpr/noexpr: inconsistent use of
    romanisation
  [15263] localedata: LC_MESSAGES.yesexpr/noexpr: inconsistent use of 1/0
    and +/-
  [15264] localedata: LC_MESSAGES.yesstr/nostr: lacking in many locales
  [15368] nptl: raise() is not async-signal-safe
  [15479] math: ceil, floor, round and trunc raise inexact exception
  [15578] localedata: kk_KZ: various updates
  [16003] localedata: pap_AN: punt old locale
  [16137] localedata: iw_IL: punt old locale
  [16190] localedata: eo: new esperanto locale
  [16374] localedata: lv_LV: change currency symbol in LC_MONETARY to euro
  [16742] malloc: race condition: pthread_atfork() called before first
    malloc() results in unexpected locking behaviour/deadlocks
  [16975] localedata: LC_MESSAGES.yesexpr/noexpr: revisit capitalization in
    all locales
  [16983] localedata: postal_fmt does not allow %l and %n modifiers
  [17565] localedata: pt_PT: wrong (work-)week start
  [17899] math: [powerpc] floorl returns negative zero with FE_DOWNWARD
  [17950] build: Build fails with -msse
  [18205] localedata: be_BY*: wrong first_weekday and first_workday
  [18433] libc: posix_spawn does not return correctly upon failure to
    execute
  [18453] localedata: charmaps/IBM875: incorrect codes
  [18712] string: bits/string2.h incompatible with -O2 -Werror=packed
    -Wsystem-headers
  [18896] localedata: he_IL: improvements for currency
  [18911] localedata: ro_RO: Correcting week day name for "Tuesday" in
    Romanian locale data
  [18960] locale: s390: _nl_locale_subfreeres uses larl opcode on misaligned
    symbol
  [19056] libc: Deprecate readdir_r
  [19133] localedata: pt_*: days & months should be lowercase in Portuguese
    language
  [19198] localedata: nl_NL: small improvements for Dutch locales
  [19257] network: Per-thread memory leak in __res_vinit with IPv6
    nameservers (CVE-2016-5417)
  [19269] build: tst-audit4 and tst-audit10 failures with gcc-6 on non avx
    machine
  [19400] locale: Language missing in  "iso-639.def", trivial fix in
    description
  [19431] malloc: Deadlock between fflush, getdelim, and fork
  [19505] libc: Incorrect file descriptor validity checks in
    posix_spawn_file_actions_add{open,close,dup2}
  [19509] dynamic-link: dlsym, dlvsym do not report errors through dlerror
    when using RTLD_NEXT
  [19512] locale: Stale `#ifndef HAVE_BUILTIN_EXPECT' in
    `intl/{gettextP,loadinfo}.h'
  [19534] libc: execle, execlp may use malloc
  [19568] localedata: *_CH: Swiss locales have inconsistent start of week
  [19573] network: res_nclose and __res_maybe_init disagree about name
    server initialization, breaking Hesiod
  [19575] localedata: Status of GB18030 tables
  [19581] localedata: sr_* date_fmt string contains additional newline
  [19583] string: SSSE3_Fast_Copy_Backward flag needs to be enabled for AMD
    Excavator core
  [19592] math: [ldbl-128ibm] ceill incorrect in non-default rounding modes
  [19593] math: [ldbl-128ibm] truncl incorrect in non-default rounding modes
  [19594] math: [ldbl-128ibm] roundl incorrect in non-default rounding modes
  [19595] math: [ldbl-128ibm] fmodl incorrect for results in subnormal
    double range
  [19602] math: [ldbl-128ibm] fmodl handling of equal arguments with low
    part zero incorrect
  [19603] math: [ldbl-128ibm] remainderl, remquol incorrect sign handling in
    equality tests
  [19610] dynamic-link: ldconfig -X removes stale symbolic links
  [19613] libc: s390x (64 bit) macro expansion WCOREDUMP and others
  [19633] locale: strfmon_l applies global locale to number formatting
  [19642] network: Memory leak in getnameinfo
  [19648] libc: test-skeleton.c: Do not set RLIMIT_DATA
  [19653] libc: Potential for NULL pointer dereference (CWE-476) in
    glibc-2.22
  [19654] math: [x86_64] Need testcase for BZ #19590 fix
  [19671] localedata: Missing Sanity Check for malloc() in 'tst-fmon.c' &
    'tst-numeric.c'
  [19674] math: [ldbl-128ibm] powl incorrect overflow handling
  [19677] math: [ldbl-128ibm] remainderl equality test incorrect for zero
    low part
  [19678] math: [ldbl-128ibm] nextafterl, nexttowardl incorrect sign of zero
    result
  [19679] dynamic-link: gcc-4.9.3 C++ exception handling broken due to
    unaligned stack
  [19726] locale: Converting UCS4LE to INTERNAL with iconv() does not update
    pointers and lengths in error-case.
  [19727] locale: Converting from/to UTF-xx with iconv() does not always
    report errors on UTF-16 surrogates values.
  [19755] nscd: nscd assertion failure in gc
  [19758] dynamic-link: Typo in EXTRA_LD_ENVVARS for x86-64
  [19759] libc: mempcpy shouldn't be inlined
  [19762] dynamic-link: HAS_CPU_FEATURE/HAS_ARCH_FEATURE are easy to misuse
  [19765] libc: s390 needs an optimized mempcpy
  [19779] glob: glob: buffer overflow with GLOB_ALTDIRFUNC due to incorrect
    NAME_MAX limit assumption (CVE-2016-1234)
  [19783] build: benchtests don't support --enable-hardcoded-path-in-tests
  [19787] network: Missing and incorrect truncation checks in getnameinfo
  [19790] math: [ldbl-128ibm] nearbyintl incorrect in non-default rounding
    modes
  [19791] network: Assertion failure in res_query.c with un-connectable name
    server addresses
  [19792] libc: MIPS: backtrace yields infinite backtrace with makecontext
  [19822] math: libm.so install clobbers old version
  [19825] network: resolv: send_vc can return uninitialized data in second
    response to getaddrinfo
  [19830] network: nss_dns: should check RDATA length against buffer length
  [19831] network: nss_dns: getaddrinfo returns uninitialized data when
    confronted with A/AAAA records of invalid size
  [19837] nss: nss_db: No retries for some long lines with a larger buffer
  [19848] math: powl(10,n) for n=-4,-5,-6,-7 is off by more than 1 ULP
  [19853] stdio: Printing IBM long double in decimal with high precision is
    sometimes incorrect
  [19860] build: x86_64: compile errors for tst-audit10 and tst-auditmod10b
  [19861] nptl: libpthread IFUNC resolver for fork can lead to crash
  [19862] network: resolv, nss_dns: Remove remaining logging of unexpected
    record types
  [19865] network: Assertion failure or memory leak in
    _nss_dns_getcanonname_r
  [19868] network: nss_dns: netent code does not skip over non-PTR records
  [19879] network: nss_dns: Stack overflow in getnetbyname implementation
    (CVE-2016-3075)
  [19881] string: Improve x86-64 memset
  [19907] string: Incorrect memcpy tests
  [19916] dynamic-link: S390: fprs/vrs are not saved/restored while
    resolving symbols
  [19925] libc: termios.h XCASE namespace
  [19928] string: memmove-vec-unaligned-erms.S is slow with large data size
  [19929] libc: limits.h NL_NMAX namespace
  [19931] stdio: Memory leak in vfprintf
  [19957] libc: clone(CLONE_VM) access invalid parent memory
  [19963] localedata: en_IL: New locale
  [19989] stdio: stdio.h cuserid namespace
  [19994] network: getaddrinfo does not restore RES_USE_INET6 flag in
    gethosts
  [19996] locale: langinfo.h nl_langinfo_l namespace
  [20005] stdio: fflush on a file opened with fmemopen resets position to 0
  [20010] network: getaddrinfo: Stack overflow in hostent translation
    (CVE-2016-3706)
  [20012] stdio: libio: fmemopen append mode failure
  [20014] stdio: stdio.h namespace for pre-threads POSIX
  [20017] network: resolv: Use gmtime_r instead of gmtime in p_secstodate
  [20023] libc: fcntl.h timespec namespace
  [20024] math: [x86_64] vectorized sincos trashes the stack
  [20031] network: nss_hesiod: Heap overflow in get_txt_records
  [20041] time: sys/time.h timespec namespace
  [20043] libc: unistd.h missing cuserid for UNIX98 and before
  [20044] libc: unistd.h missing pthread_atfork for UNIX98
  [20051] libc: ttyslot in wrong header under wrong conditions
  [20054] libc: gethostname not declared for XPG4
  [20055] libc: termios.h missing tcgetsid for XPG4
  [20072] dynamic-link: x86 init_cpu_features is called twice in static
    executable
  [20073] libc: sys/stat.h fchmod namespace
  [20074] libc: stdlib.h rand_r namespace
  [20076] libc: sys/stat.h missing S_IFSOCK, S_ISSOCK for XPG4
  [20094] libc: stdlib.h should not declare grantpt, ptsname, unlockpt for
    XPG3
  [20111] libc: struct sockaddr_storage cannot be aggregate-copied
  [20112] network: sunrpc: stack (frame) overflow in Sun RPC clntudp_call
    (CVE-2016-4429)
  [20115] string: Extra alignment in memset-vec-unaligned-erms.S
  [20119] libc: Wrong mask for processors level type from CPUID
  [20139] dynamic-link: Upper part of zmm is zeroed if Glibc is built with
    AS not supporting AVX512
  [20151] math: [ldbl-128/ldbl-128ibm] j0l, j1l, y0l, y1l return sNaN for
    sNaN argument
  [20153] math: [ldbl-128ibm] sqrtl (sNaN) returns sNaN
  [20156] math: [ldbl-128ibm] ceill, rintl etc. return sNaN for sNaN
    argument
  [20157] math: [powerpc] fabsl (sNaN) wrongly raises "invalid"
  [20160] math: [powerpc] ceil, rint etc. return sNaN for sNaN input
  [20178] libc: posix_spawn{p} should not call exit
  [20191] stdio: libio: vtables hardening
  [20195] string: FMA4 detection requires CPUID execution with register
    eax=0x80000001
  [20198] libc: quick_exit incorrectly destroys C++11 thread objects.
  [20205] math: [i386/x86_64] nextafterl incorrect incrementing negative
    subnormals
  [20212] math: acos (sNaN) returns sNaN
  [20213] math: asin (sNaN) returns sNaN
  [20214] network: Linux header sync with linux/in6.h and ipv6.h again.
  [20218] math: [i386] asinhl (sNaN) returns sNaN
  [20219] math: [i386] atanhl (sNaN) returns sNaN
  [20222] stdio: fopencookie: Mangle function pointers
  [20224] math: [i386] cbrtl (sNaN) returns sNaN
  [20225] math: ldexp, scalbn, scalbln return sNaN for sNaN input
  [20226] math: [i386/x86_64] expl, exp10l, expm1l return sNaN for sNaN
    input
  [20227] math: [i386/x86_64] logl (sNaN) returns sNaN
  [20228] math: [i386/x86_64] log10l (sNaN) returns sNaN
  [20229] math: [i386/x86_64] log1pl (sNaN) returns sNaN
  [20232] math: [ldbl-128] expm1l (sNaN) returns sNaN
  [20233] math: [ldbl-128ibm] expm1l (sNaN) returns sNaN
  [20234] math: [ldbl-128ibm] log1pl (sNaN) returns sNaN
  [20235] math: [i386/x86_64] log2l (sNaN) returns sNaN
  [20237] nss: nss_db: get*ent segfaults without preceding set*ent
  [20240] math: modf (sNaN) returns sNaN
  [20248] libc: debug/tst-longjump_chk2 calls printf from a signal handler
  [20250] math: frexp (sNaN) returns sNaN
  [20252] math: atan2 (sNaN, qNaN) fails to raise "invalid"
  [20255] math: [i386] fdim, fdimf return with excess range and precision /
    double rounding
  [20256] math: [i386/x86_64] fdiml returns sNaN for sNaN input
  [20260] string: ../sysdeps/x86/bits/string.h:1092:3: error: array
    subscript is below array bounds [-Werror=array-bounds]
  [20262] nis: _nss_nis_initgroups_dyn always returns NSS_STATUS_NOTFOUND
  [20263] nptl: robust mutex deadlocks if other thread requests timedlock
    (Only arm/linux)
  [20277] libc: $dp is not initialized correctly in sysdeps/hppa/start.S
  [20284] malloc: malloc: Corrupt arena avoidance causes unnecessary mmap
    fallbacks
  [20296] math: [i386/x86_64] scalbl returns sNaN for sNaN input, missing
    "invalid" exceptions
  [20314] nptl: make[4]: *** [/usr/include/stdlib.h] Error 1
  [20316] localedata: id_ID: Februari instead of Pebruari
  [20327] string: POWER8 strcasecmp returns incorrect result
  [20347] math: Failure: Test: j0_downward (0xap+0)
  [20348] libc: FAIL: misc/tst-preadvwritev64
  [20349] libc: 64-bit value is passed differently in p{readv,writev}{64}
  [20350] libc: There is no test for p{read,write}64
  [20357] math: Incorrect cos result for 1.5174239687223976
  [20384] build: Don't run libmvec-sincos-avx* tests on non avx machines

Contributors
============

This release was made possible by the contributions of many people.
The maintainers are grateful to everyone who has contributed
changes or bug reports.  These include:

Adhemerval Zanella
Andreas Schwab
Andrew Senkevich
Anton Blanchard
Arnas Udovičius
Aurelien Jarno
Carlos Eduardo Seo
Carlos O'Donell
Chris Metcalf
Chung-Lin Tang
Claude Paroz
Dimitris Pappas
Dmitry V. Levin
Dylan Alex Simon
Eduardo Trápani
Florian Weimer
Gabriel F. T. Gomes
Gunnar Hjalmarsson
Gustavo Romero
Guy Rutenberg
H.J. Lu
Hongjiu Zhang
Jiyoung Yun
John David Anglin
Joseph Myers
Khem Raj
Maciej W. Rozycki
Mark Wielaard
Marko Myllynen
Martin Galvan
Matthew Fortune
Matthias Wallnoefer
Mike FABIAN
Mike Frysinger
Neskie Manuel
Nick Alcock
Paras pradhan
Paul E. Murphy
Paul Pluzhnikov
Rajalakshmi Srinivasaraghavan
Rical Jasan
Richard Henderson
Robin van der Vliet
Roland McGrath
Samuel Thibault
Siddhesh Poyarekar
Simion Onea
Stefan Liebler
Stephen Gallagher
Szabolcs Nagy
Timur Birsh
Torvald Riegel
Tulio Magno Quites Machado Filho
Wilco Dijkstra
Will Newton
Yvan Roux
Zack Weinberg
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1

iQIcBAABAgAGBQJXoAmUAAoJEBZ5K06iU0D4Nx8P/3EGutqtVg6OubIKw9izzWMO
6pNj7Iy569Bk+ER2ElR5xvTeumpVS05A8r94oXX0rzCNsFIAVct7Ocr62r/OQz8A
+p6W+USpORha6m+SzY1bkI1109RR6Q4jpbENkhk/JKcBXJ7AHWHeW72QKMP0+JJu
QBavQ8b3ZLJQ4X+Be10bjseTaqAn4XNYj6fmajQC2x7F0sL32+xFjSktw8hn9AFs
A32yS3c2v/GfqKIyNj4Yz/akZzffACZ+8twVkJGDK5eoMGGQ/Obr3yttzKSNsN+O
n73HyyP4O8dG/U+v5k0IR4drT6mnUFRHUvkN10VahCHiTSG5AFQut30lwvVKzhF6
VYylPzbhOcVnSuJqdT4xJ6sumvQl5W4IAb/GKSso62MrcKFYPFdnx0wgMX6Arlgm
wkuSkSQCOfj/be2/R88alRJYNTW39vsPqKPop5ov/uXbfHqIoFcQitS0vDFJqGIC
zOhJSlV0cS/StKkw0xNgQ6Ay/dnHMm2Hzg5lqRzaQblkDVrNfN7TqyeZBEhwh3N5
KifvkdKSO6L6N7dM3nLsT+qJWoSp8dNsQ+qCHL6A/hL0SA4nxJ3hmC5hanCL+7D8
MrO5m+Z5yjpdSWFDmJv2LZsIzYX2UGZmUO19c7zvZoIrXuJE4bQXEmM4rylrNXGS
Lcke/0PPdvDeSW7iWjjP
=j7Oo
-----END PGP SIGNATURE-----

Adhemerval Zanella (40):
      Open development for 2.24.
      Updated translations for 2.23.
      Regenerate libc.pot for 2.23.
      Regenerated configure scripts.
      Update NEWS with 2.24 template
      posix: Remove dynamic memory allocation from execl{e,p}
      posix: execvpe cleanup
      posix: New Linux posix_spawn{p} implementation
      posix: Fix tst-execvpe5 for --enable-hardcoded-path-in-tests
      posix: Fix posix_spawn invalid memory access
      posix: Fix posix_spawn implict check style
      Fix tst-dlsym-error build
      Improve generic strspn performance
      Improve generic strpbrk performance
      Remove powerpc64 strspn, strcspn, and strpbrk implementation
      Use PTR_ALIGN_DOWN on strcspn and strspn
      Define __ASSUME_ALIGNED_REGISTER_PAIRS for missing ports
      Consolidate off_t/off64_t syscall argument passing
      Consolidate pread/pread64 implementations
      Consolidate pwrite/pwrite64 implementations
      Fix pread consolidation on ports that require argument alignment
      libio: Update internal fmemopen position after write (BZ #20005)
      Fix clone (CLONE_VM) pid/tid reset (BZ#19957)
      libio: Fix fmemopen append mode failure (BZ# 20012)
      powerpc: Fix clone CLONE_VM compare
      Adjust kernel-features.h defaults for recvmsg and sendmsg
      network: recvmsg and sendmsg standard compliance (BZ#16919)
      network: recvmmsg and sendmmsg standard compliance (BZ#16919)
      network: Fix missing bits from {recv,send}{m}msg standard com,pliance
      posix: Call _exit in failure case for posix_spawn{p} (BZ#20178)
      Consolidate preadv/preadv64 implementation
      Consolidate pwritev/pwritev64 implementations
      Revert {send,sendm,recv,recvm}msg conformance changes
      Remove __ASSUME_FUTEX_LOCK_PI
      nptl: Add sendmmsg and recvmmsg cancellation tests
      Fix p{readv,writev}{64} consolidation implementation
      nptl: Add more coverage in tst-cancel4
      Remove __ASSUME_OFF_DIFF_OFF64 definition
      Fix LO_HI_LONG definition
      Refactor Linux raise implementation (BZ#15368)

Andreas Schwab (13):
      Don't use long double math functions if NO_LONG_DOUBLE
      Fix min/max needed for ascii to INTERNAL conversion
      Fix compilation of test-signgam-* tests
      Fix resource leak in resolver (bug 19257)
      Register extra test objects
      m68k: avoid local labels in symbol table
      m68k: use large PIC model for gcrt1.o
      Use __typeof instead of typeof
      Fix nscd assertion failure in gc (bug 19755)
      Avoid array-bounds warning for strncat on i586 (bug 20260)
      Return proper status from _nss_nis_initgroups_dyn (bug 20262)
      m68k: suppress -Wframe-address warning
      Add test case for bug 20263

Andrew Senkevich (2):
      Added tests to ensure linkage through libmvec *_finite aliases which are
      Fixed wrong vector sincos/sincosf ABI to have it compatible with

Anton Blanchard (1):
      powerpc: Add a POWER8-optimized version of sinf()

Arnas Udovičius (1):
      localedata: sgs_LT: new locale [BZ #12450]

Aurelien Jarno (17):
      Add placeholder libnsl.abilist and libutil.abilist files
      Add sys/auxv.h wrapper to include/sys/
      mips: terminate the FDE before the return trampoline in makecontext
      Assume __NR_openat is always defined
      Assume __NR_utimensat is always defined
      Synchronize <sys/personality.h> with kernel headers
      MIPS, SPARC: fix wrong vfork aliases in libpthread.so
      MIPS, SPARC: more fixes to the vfork aliases in libpthread.so
      MIPS: run tst-mode-switch-{1,2,3}.c using test-skeleton.c
      i686/multiarch: Regenerate ulps
      SPARC64: update localplt.data
      SPARC: fix nearbyint on sNaN input
      New locale de_LI
      localedata: fix de_LI locale
      ppc: Fix modf (sNaN) for pre-POWER5+ CPU (bug 20240).
      Define __USE_KERNEL_IPV6_DEFS macro for non-Linux kernels
      sparc: remove ceil, floor, trunc sparc specific implementations

Carlos Eduardo Seo (2):
      powerpc: Fix dl-procinfo HWCAP
      powerpc: Optimization for strlen for POWER8.

Carlos O'Donell (16):
      nptl: support thread stacks that grow up
      GB 18030-2005: Document non-rountrip and PUA mappings (bug 19575).
      Enable --localedir to set message catalog directory (Bug 14259)
      NEWS (2.23): Fix typo in bug 19048 text.
      Removed unused timezone/checktab.awk.
      Remove mention of checktab.awk in timezone/README.
      Fix building glibc master with NDEBUG and --with-cpu.
      localedata: an_ES: fix case of lang_ab
      Fix macro API for __USE_KERNEL_IPV6_DEFS.
      Fix include/wchar.h for C++
      Bug 20198: quick_exit should not call destructors.
      Bug 20214: Fix linux/in6.h and netinet/in.h sync.
      Bug 20215: Always undefine __always_inline before defining it.
      Expand comments in Linux times() implementation.
      Update libc.pot and NEWS.
      Update for glibc 2.24 release.

Chris Metcalf (2):
      Bump up tst-malloc-thread-fail timeout from 20 to 30s
      tile: only define __ASSUME_ALIGNED_REGISTER_PAIRS for 32-bit

Chung-Lin Tang (2):
      Fix stdlib/tst-makecontext regression for Nios II
      Nios II localplt.data update: remove __eqsf2

Claude Paroz (1):
      localedata: ln_CD: new locale [BZ #12676]

Dimitris Pappas (1):
      charmaps: IBM875: fix mapping of iota/upsilon variants [BZ #18453]

Dmitry V. Levin (1):
      intl: reintroduce unintentionally disabled optimization

Dylan Alex Simon (1):
      math: don't clobber old libm.so on install [BZ #19822]

Eduardo Trápani (1):
      localedata: eo: new Esperanto locale [BZ #16190]

Florian Weimer (91):
      tst-malloc-thread-exit: Use fewer system resources
      Remove trailing newline from date_fmt in Serbian locales [BZ #19581]
      Improve file descriptor checks for posix_spawn actions [BZ #19505]
      res_ninit: Update comment
      malloc: Remove arena_mem variable
      malloc: Remove max_total_mem member form struct malloc_par
      malloc: Remove NO_THREADS
      Deprecate readdir_r, readdir64_r [BZ #19056]
      test-skeleton.c: Do not set RLIMIT_DATA [BZ #19648]
      tst-audit4, tst-audit10: Compile AVX/AVX-512 code separately [BZ #19269]
      libio: Clean up _IO_file_doallocate and _IO_wfile_doallocate
      ldconfig: Do not remove stale symbolic links with -X [BZ #19610]
      sunrpc: In key_call_keyenvoy, use int status instead of union wait
      tst-audit10: Fix compilation on compilers without bit_AVX512F [BZ #19860]
      resolv: Always set *resplen2 out parameter in send_dg [BZ #19791]
      nss_db: Propagate ERANGE error if parse_line fails [BZ #19837]
      CVE-2016-3075: Stack overflow in _nss_dns_getnetbyname_r [BZ #19879]
      Report dlsym, dlvsym lookup errors using dlerror [BZ #19509]
      strfmon_l: Use specified locale for number formatting [BZ #19633]
      scratch_buffer_set_array_size: Include <limits.h>
      hsearch_r: Include <limits.h>
      Add missing bug number to ChangeLog
      nss_dns: Fix assertion failure in _nss_dns_getcanonname_r [BZ #19865]
      Remove union wait [BZ #19613]
      malloc: Run fork handler as late as possible [BZ #19431]
      malloc: Remove unused definitions of thread_atfork, thread_atfork_static
      malloc: Remove malloc hooks from fork handler
      malloc: Add missing internal_function attributes on function definitions
      vfprintf: Fix memory with large width and precision [BZ #19931]
      resolv: Always set *resplen2 out parameter in send_vc [BZ #19825]
      nss_dns: Validate RDATA length against packet length [BZ #19830]
      resolv, nss_dns: Remove remaining syslog logging [BZ #19862]
      nss_dns: Check address length before creating addrinfo result [BZ #19831]
      nss_dns: Remove custom offsetof macro definition
      nss_dns: Skip over non-PTR records in the netent code [BZ #19868]
      Fix ChangeLog date to reflect commit date
      resolv: Remove SCCS and RCS keywords
      resolv: Remove _LIBC conditionals
      inet: Remove SCCS keywords
      resolv: Remove BIND_UPDATE preprocessor conditionals
      resolv: Remove RESOLVSORT preprocess conditionals
      resolv: Remove RFC1535 conditionals
      resolv: Remove traces of ULTRIX support
      resolv: Remove __BIND_NOSTATIC conditionals
      resolv: Remove BSD compatibility conditionals and header
      resolv: Remove SUNSECURITY preprocessor conditionals
      resolv: Assorted preprocessor cleanups
      resolv: Reindent preprocessor conditionals following cleanups
      getnameinfo: Do not preserve errno
      glob: Simplify the interface for the GLOB_ALTDIRFUNC callback gl_readdir
      CVE-2016-3706: getaddrinfo: stack overflow in hostent conversion [BZ #20010]
      NEWS entry for CVE-2016-3075
      getnameinfo: Refactor and fix memory leak [BZ #19642]
      hesiod: Remove RCS keywords
      hesiod: Remove DEF_RHS
      hesiod: Always use thread-local resolver state [BZ #19573]
      hesiod: Avoid heap overflow in get_txt_records [BZ #20031]
      CVE-2016-1234: glob: Do not copy d_name field of struct dirent [BZ #19779]
      getnameinfo: Reduce line length and add missing comments
      getnameinfo: Avoid calling strnlen on uninitialized buffer
      getnameinfo: Return EAI_OVERFLOW in more cases [BZ #19787]
      malloc: Adjust header file guard in malloc-internal.h
      getaddrinfo: Restore RES_USE_INET6 flag on error path [BZ #19994]
      resolv: Call gmtime_r instead of gmtime in p_secstodate [BZ #20017]
      localedef: Do not compile with mcheck
      getaddrinfo: Convert from extend_alloca to struct scratch_buffer
      Increase fork signal safety for single-threaded processes [BZ #19703]
      malloc: Rewrite dumped heap for compatibility in __malloc_set_state
      tst-mallocfork2: Fix race condition, use fewer resources
      Make padding in struct sockaddr_storage explicit [BZ #20111]
      CVE-2016-4429: sunrpc: Do not use alloca in clntudp_call [BZ #20112]
      malloc: Correct malloc alignment on 32-bit architectures [BZ #6527]
      fork in libpthread cannot use IFUNC resolver [BZ #19861]
      libio: Use wmemset instead of __wmemset to avoid linknamespace issue
      tst-rec-dlopen: Use interposed malloc instead of hooks
      malloc: Correct size computation in realloc for dumped fake mmapped chunks
      quick_exit tests: Do not use C++ headers
      malloc: Remove __malloc_initialize_hook from the API [BZ #19564]
      fopencookie: Mangle function pointers stored on the heap [BZ #20222]
      malloc_usable_size: Use correct size for dumped fake mapped chunks
      nss_db: Fix initialization of iteration position [BZ #20237]
      debug/tst-longjmp_chk2: Make signal handler more conservative [BZ #20248]
      Revert __malloc_initialize_hook symbol poisoning
      elf: Consolidate machine-agnostic DTV definitions in <dl-dtv.h>
      malloc: Avoid premature fallback to mmap [BZ #20284]
      test-skeleton.c: Add write_message function
      test-skeleton.c: xmalloc, xcalloc, xrealloc are potentially unused
      test-skeleton.c (xrealloc): Support realloc-as-free
      libio: Implement vtable verification [BZ #20191]
      Correct bug number in ChangeLog [BZ #18960]
      CVE-2016-5417 was assigned to bug 19257

Gabriel F. T. Gomes (3):
      powerpc: Remove uses of operand modifier (%s) in inline asm
      powerpc: Zero pad using memset in strncpy/stpncpy
      powerpc: Fix operand prefixes

Gunnar Hjalmarsson (1):
      localedata: id_ID: Februari instead of Pebruari [BZ #20316]

Gustavo Romero (1):
      powerpc: Fix missing verb and typo in comment about AT_HWCAP entry

Guy Rutenberg (1):
      localedata: en_IL: new English locale [BZ #19963]

H.J. Lu (68):
      [x86_64] Set DL_RUNTIME_UNALIGNED_VEC_SIZE to 8
      Call x86-64 __setcontext directly
      Call x86-64 __mcount_internal/__sigjmp_save directly
      Copy x86_64 _mcount.op from _mcount.o
      Or bit_Prefer_MAP_32BIT_EXEC in EXTRA_LD_ENVVARS
      x86-64: Fix memcpy IFUNC selection
      Add a comment in sysdeps/x86_64/Makefile
      Replace @PLT with @GOTPCREL(%rip) in call
      Replace PREINIT_FUNCTION@PLT with *%rax in call
      Use HAS_ARCH_FEATURE with Fast_Rep_String
      Group AVX512 functions in .text.avx512 section
      Support --enable-hardcoded-path-in-tests in benchtests
      Define _HAVE_STRING_ARCH_mempcpy to 1 for x86
      Add _arch_/_cpu_ to index_*/bit_* in x86 cpu-features.h
      Use JUMPTARGET in x86-64 mathvec
      Use JUMPTARGET in x86-64 pthread
      Set index_arch_AVX_Fast_Unaligned_Load only for Intel processors
      Don't set %rcx twice before "rep movsb"
      [x86] Add a feature bit: Fast_Unaligned_Copy
      Implement x86-64 multiarch mempcpy in memcpy
      Make __memcpy_avx512_no_vzeroupper an alias
      Initial Enhanced REP MOVSB/STOSB (ERMS) support
      Add x86-64 memmove with unaligned load/store and rep movsb
      Add x86-64 memset with unaligned store and rep stosb
      Test 64-byte alignment in memcpy benchtest
      Test 64-byte alignment in memmove benchtest
      Test 64-byte alignment in memset benchtest
      Remove Fast_Copy_Backward from Intel Core processors
      Fix memmove-vec-unaligned-erms.S
      Don't put SSE2/AVX/AVX512 memmove/memset in ld.so
      Add a comment in memset-sse2-unaligned-erms.S
      Force 32-bit displacement in memset-vec-unaligned-erms.S
      Add memcpy/memmove/memset benchmarks with large data
      X86-64: Prepare memset-vec-unaligned-erms.S
      X86-64: Prepare memmove-vec-unaligned-erms.S
      X86-64: Use non-temporal store in memcpy on large data
      Detect Intel Goldmont and Airmont processors
      Reduce number of mmap calls from __libc_memalign in ld.so
      Move sysdeps/x86_64/cacheinfo.c to sysdeps/x86
      Remove x86 ifunc-defines.sym and rtld-global-offsets.sym
      Support non-inclusive caches on Intel processors
      Call init_cpu_features only if SHARED is defined
      Clear destination buffer updated by the previous run
      Don't call internal __pthread_unwind via PLT
      Don't call internal _Unwind_Resume via PLT
      Remove alignments on jump targets in memset
      Check the HTT bit before counting logical threads
      Correct Intel processor level type mask from CPUID
      Remove special L2 cache case for Knights Landing
      Avoid an extra branch to PLT for -z now
      Count number of logical processors sharing L2 cache
      Fix a typo in comments in memmove-vec-unaligned-erms.S
      Check FMA after COMMON_CPUID_INDEX_80000001
      X86-64: Remove the previous SSE2/AVX2 memsets
      X86-64: Remove previous default/SSE2/AVX2 memcpy/memmove
      X86-64: Add dummy memcopy.h and wordcopy.c
      Always indirect branch to __libc_start_main via GOT
      Compile tst-cleanupx4 test with -fexceptions
      Check Prefer_ERMS in memmove/memcpy/mempcpy/memset
      Require binutils 2.24 to build x86-64 glibc [BZ #20139]
      Make copies of cstdlib/cmath and use them [BZ #20314]
      X86-64: Define LO_HI_LONG to skip pos_h [BZ #20349]
      x86-64: Properly align stack in _dl_tlsdesc_dynamic [BZ #20309]
      Test p{read,write}64 with offset > 4GB
      x86-64: Add p{read,write}[v]64 to syscalls.list [BZ #20348]
      Regenerate i686 libm-test-ulps with GCC 6.1 at -O3 [BZ #20347]
      i386: Compile rtld-*.os with -mno-sse -mno-mmx -mfpmath=387
      Don't compile do_test with -mavx/-mavx/-mavx512

Hongjiu Zhang (1):
      sln: use stat64

Jiyoung Yun (1):
      Fix robust mutex daedlock [BZ #20263]

John David Anglin (2):
      hppa: fix loading of global pointer in _start [BZ #20277]
      hppa: Update libm-test-ulps.

Joseph Myers (107):
      Fix ldbl-128ibm floorl for non-default rounding modes (bug 17899).
      Fix ldbl-128ibm ceill for non-default rounding modes (bug 19592).
      Fix ldbl-128ibm truncl for non-default rounding modes (bug 19593).
      Fix ldbl-128ibm roundl for non-default rounding modes (bug 19594).
      Fix ldbl-128ibm fmodl handling of subnormal results (bug 19595).
      Fix ldbl-128ibm fmodl handling of equal arguments with low part zero (bug 19602).
      Fix ldbl-128ibm remainderl, remquol equality tests (bug 19603).
      Fix ldbl-128ibm powl overflow handling (bug 19674).
      Fix ldbl-128ibm nextafterl, nexttowardl sign of zero result (bug 19678).
      Require Linux 3.2 except on x86 / x86_64, 3.2 headers everywhere.
      Remove linux/fanotify.h configure test.
      Remove kernel-features.h conditionals on pre-3.2 kernels.
      Fix ldbl-128ibm remainderl equality test for zero low part (bug 19677).
      Fix ldbl-128ibm nearbyintl in non-default rounding modes (bug 19790).
      Allow spurious underflow / inexact for ldbl-128ibm.
      Update glibc headers for Linux 4.5.
      Adjust kernel-features.h defaults for socket syscalls.
      Remove __ASSUME_PPOLL.
      Remove __ASSUME_FALLOCATE.
      Remove __ASSUME_EVENTFD2, move eventfd to syscalls.list.
      Remove __ASSUME_SIGNALFD4.
      Remove __ASSUME_GETDENTS64_SYSCALL.
      Fix x86_64 / x86 powl inaccuracy for integer exponents (bug 19848).
      [microblaze] Remove __ASSUME_FUTIMESAT.
      Fix termios.h XCASE namespace (bug 19925).
      Fix limits.h NL_NMAX namespace (bug 19929).
      Fix stdio.h cuserid namespace (bug 19989).
      Define off_t in stdio.h for XOPEN2K.
      conformtest: Correct XOPEN2K stdarg.h expectations.
      Fix langinfo.h nl_langinfo_l namespace (bug 19996).
      conformtest: Correct some signal.h expectations for XOPEN2K.
      conformtest: Correct some stdio.h expectations for UNIX98.
      conformtest: Correct stdio.h expectations for fdopen.
      Also define off_t in stdio.h for UNIX98.
      conformtest: Add langinfo.h expectations for YESSTR, NOSTR.
      Fix stdio.h namespace for pre-threads POSIX (bug 20014).
      Fix fcntl.h timespec namespace (bug 20023).
      Fix sys/time.h timespec namespace (bug 20041).
      conformtest: Remove some bogus sys/types.h expectations for XPG3 and XPG4.
      Declare cuserid in unistd.h for UNIX98 and before (bug 20043).
      Declare pthread_atfork in unistd.h for UNIX98 (bug 20044).
      conformtest: Fix st_blksize, st_blocks expectations for XPG3, XPG4.
      conformtest: Correct some sys/stat.h expectations for XPG3.
      Fix sys/stat.h fchmod namespace (bug 20073).
      Declare tcgetsid for XPG4 (bug 20055).
      conformtest: Do not expect S_IF* in fcntl.h.
      Declare gethostname for XPG4 (bug 20054).
      conformtest: Correct some unistd.h expectations for XPG3, XPG4.
      conformtest: Correct time.h XPG3 expectations.
      conformtest: Do not expect strdup in string.h for XPG3.
      conformtest: Correct some stdlib.h expectations for XPG3.
      Correct ttyslot header declaration conditions (bug 20051).
      Fix stdlib.h rand_r namespace (bug 20074).
      Make sys/stat.h define S_IFSOCK, S_ISSOCK for XPG4 (bug 20076).
      Do not declare grantpt, ptsname, unlockpt in stdlib.h for XPG3 (bug 20094).
      Add Q_GETNEXTQUOTA from Linux 4.6 to sys/quota.h.
      Add CLONE_NEWCGROUP from Linux 4.6 to bits/sched.h.
      Update libm-test.inc comment about NaN signs.
      conformtest: Correct search.h expectations for XPG3.
      conformtest: Correct pwd.h expectations for XPG3.
      Implement proper fmal for ldbl-128ibm (bug 13304).
      conformtest: Correct ftw.h expectations for XPG3, XPG4.
      Update sysdeps/unix/sysv/linux/bits/socket.h for Linux 4.6.
      conformtest: Correct some limits.h expectations for XPG3, XPG4.
      Do not raise "inexact" from generic ceil (bug 15479).
      Do not raise "inexact" from generic floor (bug 15479).
      Do not raise "inexact" from generic round (bug 15479).
      Do not raise "inexact" from x86_64 SSE4.1 ceil, floor (bug 15479).
      Do not raise "inexact" from powerpc32 ceil, floor, trunc (bug 15479).
      Do not raise "inexact" from powerpc64 ceil, floor, trunc (bug 15479).
      Support sNaN testing in libm-test.inc.
      Add more sNaN tests to libm-test.inc.
      Fix ldbl-128 j0l, j1l, y0l, y1l for sNaN argument (bug 20151).
      Fix ldbl-128ibm sqrtl (sNaN) (bug 20153).
      Fix ldbl-128ibm ceill, rintl etc. for sNaN arguments (bug 20156).
      Remove unused macros from libm-test.inc.
      Avoid "invalid" exceptions from powerpc fabsl (sNaN) (bug 20157).
      Fix powerpc32 ceil, rint etc. on sNaN input (bug 20160).
      Fix powerpc64 ceil, rint etc. on sNaN input (bug 20160).
      Fix x86/x86_64 nextafterl incrementing negative subnormals (bug 20205).
      Fix dbl-64 acos (sNaN) (bug 20212).
      Fix dbl-64 asin (sNaN) (bug 20213).
      Fix i386 asinhl (sNaN) (bug 20218).
      Fix i386 atanhl (sNaN) (bug 20219).
      Fix i386 cbrtl (sNaN) (bug 20224).
      Fix ldexp, scalbn, scalbln for sNaN input (bug 20225).
      Fix i386/x86_64 expl, exp10l, expm1l for sNaN input (bug 20226).
      Fix i386/x86_64 logl (sNaN) (bug 20227).
      Fix i386/x86_64 log10l (sNaN) (bug 20228).
      Fix i386/x86_64 log1pl (sNaN) (bug 20229).
      Fix ldbl-128 expm1l (sNaN) (bug 20232).
      Fix ldbl-128ibm expm1l (sNaN) (bug 20233).
      Fix ldbl-128ibm log1pl (sNaN) (bug 20234).
      Fix i386/x86_64 log2l (sNaN) (bug 20235).
      Fix modf (sNaN) (bug 20240).
      Fix frexp (NaN) (bug 20250).
      Add more sNaN tests (cimag, conj, copysign, creal, fma, fmod).
      Fix dbl-64 atan2 (sNaN, qNaN) (bug 20252).
      Simplify generic fdim implementations.
      Use generic fdim on more architectures (bug 6796, bug 20255, bug 20256).
      Fix i386 fdim double rounding (bug 20255).
      Simplify x86 nearbyint functions.
      Add more sNaN tests (most remaining real functions).
      Fix i386/x86_64 scalbl with sNaN input (bug 20296).
      Avoid "inexact" exceptions in i386/x86_64 ceil functions (bug 15479).
      Avoid "inexact" exceptions in i386/x86_64 floor functions (bug 15479).
      Avoid "inexact" exceptions in i386/x86_64 trunc functions (bug 15479).

Khem Raj (2):
      When disabling SSE, make sure -fpmath is not set to use SSE either
      elf: Define missing Meta architecture specific relocations

Maciej W. Rozycki (1):
      Treat STV_HIDDEN and STV_INTERNAL symbols as STB_LOCAL

Mark Wielaard (2):
      elf/elf.h: Add new 386 and X86_64 relocations from binutils.
      elf.h: Add NT_ARM_SYSTEM_CALL constant.

Marko Myllynen (1):
      localedef: drop unused --old-style

Martin Galvan (1):
      Add pretty printers for the NPTL lock types

Matthew Fortune (1):
      VDSO support for MIPS

Matthias Wallnoefer (2):
      localedata: de_{AT,CH}: copy data from de_DE
      localedata: de_IT: new locale

Mike FABIAN (1):
      localedata: i18n: fix typos in tel_int_fmt

Mike Frysinger (44):
      locledata: trim trailing blank lines/comments
      localedata: dz_BT/ps_AF: reformat data
      localedata: CLDRv28: update LC_TELEPHONE.int_prefix
      locales: pap_AN: delete old/deprecated locale [BZ #16003]
      test-skeleton: increase default TIMEOUT to 20 seconds
      localedata: an_ES: fix lang_ab value
      localedata: es_PR: change LC_MEASUREMENT to metric
      localedata: clear LC_IDENTIFICATION tel/fax fields
      link sln fix to bugzilla [BZ #15333]
      localedata: use same comment_char/escape_char in these files
      add ChangeLog entry
      localedata: standardize first few lines
      localedata: standardize copyright/license information [BZ #11213]
      localedata: iw_IL: delete old/deprecated locale [BZ #16137]
      configure: fix `test ==` usage
      localedata: CLDRv28: update LC_PAPER values
      localedata: LC_TIME.date_fmt: delete entries same as the default value
      localedata: CLDRv29: update LC_IDENTIFICATION language/territory fields
      localedata: LC_MEASUREMENT: use copy directives everywhere
      localedata: LC_PAPER: use copy directives everywhere
      localedata: CLDRv29: update LC_ADDRESS.country_num values
      localedata: fix LC_ADDRESS.country_car entries
      localedata: CLDRv29: update LC_ADDRESS.country_name translations
      localedata: LC_IDENTIFICATION.category: set to ISO 30112 2014 standard
      localedef: check LC_IDENTIFICATION.category values
      localedata: CLDRv29: update LC_MONETARY int_curr_symbol & currency_symbol
      localedata: LC_IDENTIFICATION: delete uncommon fields
      locale: ld-telephone: update to ISO-30112 2014
      localedef: allow %l/%n in postal_fmt [BZ #16983]
      localedata: fix LC_TELEPHONE in a few locales
      localedata: CLDRv29: update LC_TIME week/first_week,workday fields
      localedef: change week_1stweek default to 7
      localedata: standard LC_MESSAGES string regexes a bit
      localedata: LC_MESSAGES.{yes,no}expr: add +1/-0 to all regexes [BZ #15263]
      localedata: LC_MESSAGES.{yes,no}expr: standardize yY/nN [BZ #15262]
      localedata: CLDRv29: update LC_MESSAGES yes/no strings [BZ #15264] [BZ #16975]
      tst-langinfo: update yesexpr/noexpr baselines
      tst-fmon/tst-numeric: switch malloc to static stack space [BZ #19671]
      localedata: add more translit entries
      localedata: pt_BR/pt_PT: make days/months lowercase [BZ #19133]
      unicode-gen: include standard comment file header
      NEWS: clarify localedef --old-style update
      manual: fix spelling typos
      microblaze: fix variable name collision with syscall macros

Neskie Manuel (1):
      localedata: chr_US: new Cherokee locale [BZ #12143]

Nick Alcock (2):
      x86, pthread_cond_*wait: Do not depend on %eax not being clobbered
      Allow overriding of CFLAGS as well as CPPFLAGS for rtld.

Paras pradhan (1):
      localedata: ne_NP: misc updates [BZ #1170]

Paul E. Murphy (22):
      Increase internal precision of ldbl-128ibm decimal printf [BZ #19853]
      powerpc: Add optimized P8 strspn
      powerpc: Add optimized strcspn for P8
      powerpc: Add missing insn in swapcontext [BZ #20004]
      Refactor bug-strtod.c to better test new types.
      Refactor bug-strtod2.c to be type generic
      Refactor tst-strtod6.c
      Refactor tst-strtod-round.c
      Fixup usage of MANT_DIG in libm-test.inc
      Fixup usage of MIN_EXP in libm-test.inc
      Refactor tst-strtod-round.c for type-generic-ness
      Begin refactor of libm-test.inc
      Refactor type specific macros using regexes
      Refactor M_ macros defined in libm-test.inc
      Replace M_PI2l with lit_pi_2_d in libm-test.inc
      Replace M_PIl with lit_pi in libm-test.inc
      Replace M_PI_4l with lit_pi_4_d in libm-test.inc
      Replace M_El with lit_e in libm-test.inc
      Apply LIT(x) to floating point literals in libm-test.c
      Remove CHOOSE() macro from libm-tests.inc
      Remove type specific information from auto-libm-test-in
      Generate new format names in auto-libm-test-out

Paul Pluzhnikov (7):
      2016-03-03  Paul Pluzhnikov  <ppluzhnikov@google.com>
      2016-05-30  Paul Pluzhnikov  <ppluzhnikov@google.com>
      Merge branch 'master' of ssh://sourceware.org/git/glibc
      2016-06-05  Paul Pluzhnikov  <ppluzhnikov@google.com>
      2016-06-09  Paul Pluzhnikov  <ppluzhnikov@gmail.com>
      2016-06-11  Paul Pluzhnikov  <ppluzhnikov@google.com>
      Fix rt/tst-aio64.c as well, and mention login/tst-utmp.c in ChangeLog

Rajalakshmi Srinivasaraghavan (4):
      powerpc: Rearrange cfi_offset calls
      powerpc: strcasestr optmization for power8
      Add nextup and nextdown math functions
      powerpc: Fix return code of strcasecmp for unaligned inputs

Rical Jasan (9):
      manual: fix typos in the memory chapter
      manual: fix typos in the character handling chapter
      manual: fix typos in the string chapters
      manual: fix typos in character set handling
      manual: fix typos in the locale chapter
      manual: fix typos in the locale chapter
      manual: fix typos in the message chapter
      manual: fix typos in the search chapter
      manual: fix typos in the pattern chapter

Richard Henderson (2):
      elf.h: Sync with the gabi webpage
      elf.h: Add declarations for BPF

Robin van der Vliet (1):
      locale: iso-639: add Talossan language [BZ #19400]

Roland McGrath (9):
      Add fts64_* to sysdeps/arm/nacl/libc.abilist
      Typo fixes.
      Gratuitous change to poke buildbot.
      Fix c++-types-check conditionalization.
      Omit test-math-isinff when no C++ compiler.
      Conditionalize c++-types-check.out addition to tests-special.
      Fix edito in last change.
      Fix tst-audit10 build when -mavx512f is not supported.
      stpcpy is part of POSIX.1-2008 [BZ #3629]

Samuel Thibault (23):
      Fix flag test in waitid compatibility layer
      Fix hurd build
      hurd: Break errnos.d / libc-modules.h dependency loop
      Fix mach-syscalls.mk build
      hurd: Do not hide rtld symbols which need to be preempted
      hurd: Allow inlining IO locks
      hurd: Add c++-types expected result
      Fix malloc threaded tests link on non-Linux
      Fix crash on getauxval call without HAVE_AUX_VECTOR
      Fix build with HAVE_AUX_VECTOR
      hurd: fix profiling short-living processes
      Fix gprof timing
      non-linux: Apply RFC3542 obsoletion of RFC2292 macros
      non-linux: Apply RFC3542 obsoletion of RFC2292 macros
      aio: fix newp->running data race
      Revert "aio: fix newp->running data race"
      hurd: fix _hurd_self_sigstate reference from ____longjmp_chk
      Add more hurd exception to local headers list
      hurd: disable ifunc for now
      mach: Add mach_print sycsall declaration
      hurd: Fix PTR_{,DE}MANGLE calls
      Add missing changelog part
      Fix TABDLY value

Siddhesh Poyarekar (10):
      New make target to only build benchmark binaries
      Fix up ChangeLog formatting
      benchtests: Update README to include instructions for bench-build target
      Fix up ChangeLog
      benchtests: Clean up extra-objs
      benchtests: Support for cross-building benchmarks
      Avoid attempt for runtime checks if all environments are defined
      Fix up ChangeLog
      Revert "Add pretty printers for the NPTL lock types"
      Fix cos computation for multiple precision fallback (bz #20357)

Simion Onea (1):
      localedata: ro_RO: update Tuesday translation [BZ #18911]

Stefan Liebler (31):
      Add missing inclusion of libc-internal.h.
      S390: Save and restore fprs/vrs while resolving symbols.
      S390: Extend structs La_s390_regs / La_s390_retval with vector-registers.
      S390: Use ahi instead of aghi in 32bit _dl_runtime_resolve.
      Mention Bug in ChangeLog for S390: Save and restore fprs/vrs while resolving symbols.
      Fix strfmon_l: Use specified locale for number formatting [BZ #19633]
      Add missing iucv related defines.
      S390: Add support for vdso getcpu symbol.
      S390: Use fPIC to avoid R_390_GOT12 relocation in gcrt1.o.
      Fix tst-cancel17/tst-cancelx17, which sometimes segfaults while exiting.
      S390: Use mvcle for copies > 1MB on 32bit with default memcpy variant.
      S390: Use 64bit instruction to check for copies of > 1MB with mvcle.
      S390: Do not call memcpy, memcmp, memset within libc.so via ifunc-plt.
      S390: Implement mempcpy with help of memcpy. [BZ #19765]
      S390: Get rid of make warning: overriding recipe for target gconv-modules.
      S390: Configure check for vector support in gcc.
      S390: Optimize 8bit-generic iconv modules.
      S390: Optimize builtin iconv-modules.
      S390: Optimize iso-8859-1 to ibm037 iconv-module.
      S390: Optimize utf8-utf32 module.
      S390: Optimize utf8-utf16 module.
      S390: Optimize utf16-utf32 module.
      S390: Use s390-64 specific ionv-modules on s390-32, too.
      S390: Fix utf32 to utf8 handling of low surrogates (disable cu41).
      S390: Fix utf32 to utf16 handling of low surrogates (disable cu42).
      Fix ucs4le_internal_loop in error case. [BZ #19726]
      Fix UTF-16 surrogate handling. [BZ #19727]
      tst-rec-dlopen: Fix build fail due to missing inclusion of string.h
      S390: Fix relocation of _nl_current_LC_CATETORY_used in static build. [BZ #19860]
      S390: Use DT_JUMPREL in prelink undo code.
      S390: Do not clobber r13 with memcpy on 31bit with copies >1MB.

Stephen Gallagher (1):
      NSS: Implement group merging support.

Szabolcs Nagy (4):
      [AArch64] Fix libc internal asm profiling code
      [AArch64] Add bits/hwcap.h for aarch64 linux
      [AArch64] Regenerate libm-test-ulps
      [AArch64] Update libm-test-ulps

Timur Birsh (1):
      localedata: kk_KZ: various updates [BZ #15578]

Torvald Riegel (1):
      Remove atomic_compare_and_exchange_bool_rel.

Tulio Magno Quites Machado Filho (3):
      Fix type of parameter passed by malloc_consolidate
      powerpc: Fix --disable-multi-arch build on POWER8
      powerpc: Add a POWER8-optimized version of expf()

Wilco Dijkstra (7):
      Improve generic strcspn performance
      Remove pre GCC3.2 optimizations from string/bits/string2.h.
      Move mempcpy, strcpy and stpcpy inlines to string/string-inlines.c as compatibility
      This is an optimized memset for AArch64.  Memset is split into 4 main cases:
      This is an optimized memcpy/memmove for AArch64.  Copies are split into 3 main
      Add a simple rawmemchr implementation.  Use strlen for rawmemchr(s, '\0') as it
      This patch further tunes memcpy - avoid one branch for sizes 1-3,

Will Newton (1):
      elf/elf.h: Add missing Meta relocations

Yvan Roux (1):
      Suppress GCC 6 warning about ambiguous 'else' with -Wparentheses

Zack Weinberg (3):
      Move sysdeps/generic/bits/hwcap.h to top-level bits/
      Move sysdeps/generic/bits/hwcap.h to top-level bits/
      Don't install the internal header grp-merge.h

raji (1):
      powerpc: strcasecmp/strncasecmp optmization for power8

ricaljasan@pacific.net (2):
      manual: fix typo in the introduction
      manual: fix typos in error reporting

-----------------------------------------------------------------------
Comment 7 cvs-commit@gcc.gnu.org 2016-09-21 23:47:55 UTC
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, master has been updated
       via  e67f54ab1a6253dd69cb2c770d785c7eb6d2172c (commit)
      from  87ab10d6524fe4faabd7eb3eac5868165ecfb323 (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=e67f54ab1a6253dd69cb2c770d785c7eb6d2172c

commit e67f54ab1a6253dd69cb2c770d785c7eb6d2172c
Author: Samuel Thibault <samuel.thibault@ens-lyon.org>
Date:   Thu Sep 22 01:45:48 2016 +0200

    hurdmalloc: Run fork handler as late as possible [BZ #19431]
    
    This is the hurd-specific follow-up for
    29d794863cd6e03115d3670707cc873a9965ba92 : hurdmalloc also needs the
    same fix
    
    	* hurd/hurdmalloc.c (malloc_fork_prepare): Rename to
    	_hurd_malloc_fork_prepare.
    	(malloc_fork_parent): Rename to _hurd_malloc_fork_parent.
    	(malloc_fork_child): Rename to _hurd_malloc_fork_child.
    	(_hurd_fork_prepare_hook): Drop malloc_fork_prepare.
    	(_hurd_fork_parent_hook): Drop malloc_fork_parent.
    	(_hurd_fork_child_hook): Drop malloc_fork_child.
    	* hurd/hurdmalloc.h (_hurd_malloc_fork_prepare,
    	_hurd_malloc_fork_parent, _hurd_malloc_fork_child): Add declarations.
    	* sysdeps/mach/hurd/fork.c (__fork): Call __malloc_fork_lock_parent
    	after locking locks (notably hurd_dtable_lock). Call
    	_hurd_malloc_fork_prepare after that. Call _hurd_malloc_fork_parent
    	before __malloc_fork_unlock_parent and _hurd_malloc_fork_child before
    	__malloc_fork_unlock_child.

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog                |   17 +++++++++++++++++
 hurd/hurdmalloc.c        |   15 ++++++---------
 hurd/hurdmalloc.h        |    4 ++++
 sysdeps/mach/hurd/fork.c |   15 +++++++++------
 4 files changed, 36 insertions(+), 15 deletions(-)
Comment 8 cvs-commit@gcc.gnu.org 2016-11-12 06:40:47 UTC
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, gentoo/2.23 has been updated
       via  e7758c56a1ed29443edd5fda8c0766bda416cd5f (commit)
      from  57d20e7914f44c12a08a2125affbbb8340256a31 (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=e7758c56a1ed29443edd5fda8c0766bda416cd5f

commit e7758c56a1ed29443edd5fda8c0766bda416cd5f
Author: Florian Weimer <fweimer@redhat.com>
Date:   Thu Apr 14 09:17:02 2016 +0200

    malloc: Run fork handler as late as possible [BZ #19431]
    
    Previously, a thread M invoking fork would acquire locks in this order:
    
      (M1) malloc arena locks (in the registered fork handler)
      (M2) libio list lock
    
    A thread F invoking flush (NULL) would acquire locks in this order:
    
      (F1) libio list lock
      (F2) individual _IO_FILE locks
    
    A thread G running getdelim would use this order:
    
      (G1) _IO_FILE lock
      (G2) malloc arena lock
    
    After executing (M1), (F1), (G1), none of the threads can make progress.
    
    This commit changes the fork lock order to:
    
      (M'1) libio list lock
      (M'2) malloc arena locks
    
    It explicitly encodes the lock order in the implementations of fork,
    and does not rely on the registration order, thus avoiding the deadlock.
    
    (cherry picked from commit 29d794863cd6e03115d3670707cc873a9965ba92)
    (cherry picked from commit 2a71cf409681b89ffb8892b35cac64de79b7adb8)

-----------------------------------------------------------------------

Summary of changes:
 malloc/Makefile                                    |    3 +-
 malloc/arena.c                                     |   58 ++----
 .../timer_getoverr.c => malloc/malloc-internal.h   |   30 +--
 malloc/malloc.c                                    |    1 +
 malloc/tst-malloc-fork-deadlock.c                  |  220 ++++++++++++++++++++
 manual/memory.texi                                 |    8 -
 sysdeps/mach/hurd/fork.c                           |   13 ++
 sysdeps/nptl/fork.c                                |   13 +-
 8 files changed, 276 insertions(+), 70 deletions(-)
 copy sysdeps/unix/sysv/linux/timer_getoverr.c => malloc/malloc-internal.h (57%)
 create mode 100644 malloc/tst-malloc-fork-deadlock.c
Comment 9 cvs-commit@gcc.gnu.org 2017-01-27 15:32:42 UTC
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, linaro/2.21/master has been updated
       via  1b248392fbadaa5a81ed220fdf2f7ec3b9939b9e (commit)
       via  cf161d39113047a81f969f277707b9d1679ecf69 (commit)
       via  a274119b0e6b4800163d8d1870995e597a55cb8b (commit)
       via  a18c25e0ee00bb37c724123d8b187050e9a367a0 (commit)
       via  124ea50584d3d21fe4c2fe9383508efd0ac9010a (commit)
       via  5a8692a64640bb648de6be9877dc072d728859bd (commit)
       via  6a277a415c127f6ee9a70548c899a7ac536f4288 (commit)
       via  9e1e8f68d59e33baa0eef9e8690d3cbaa5f67a24 (commit)
       via  dd08634b37f81f01441d842087b123d12b4003d4 (commit)
       via  749c94d44c9aa063dfc7ad2b505c8e6d35e57345 (commit)
       via  b533edfeedf66e971b1b29affd8e2f1619987dc9 (commit)
       via  4b31bd831ab205ff24ae3a2b8c4f8135c182c7d7 (commit)
       via  50992336ac40625c363e1514890f92774c65054a (commit)
       via  39ad1d12448adf0682ffb8b8ac146e99b68279bf (commit)
       via  7f2efd6c269a2ab2eee80bffa5bcb2538aa89641 (commit)
      from  a68cafa11c500d8a49a3014c43c5152859d037ae (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=1b248392fbadaa5a81ed220fdf2f7ec3b9939b9e

commit 1b248392fbadaa5a81ed220fdf2f7ec3b9939b9e
Author: H.J. Lu <hjl.tools@gmail.com>
Date:   Wed Jul 29 11:57:54 2015 -0700

    Extend local PLT reference check
    
    On x86, linker in binutils 2.26 and newer consolidates R_*_JUMP_SLOT with
    R_*_GLOB_DAT relocation against the same symbol.  This patch extends
    local PLT reference check to support alternate relocations.
    
    	[BZ #18078]
    	* scripts/check-localplt.awk: Support alternate relocations.
    	* scripts/localplt.awk: Also check relocations in DT_RELA/DT_REL
    	sections.
    	* sysdeps/unix/sysv/linux/i386/localplt.data: Mark free and
    	malloc entries with + REL R_386_GLOB_DAT.
    	* sysdeps/x86_64/localplt.data: New file.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=cf161d39113047a81f969f277707b9d1679ecf69

commit cf161d39113047a81f969f277707b9d1679ecf69
Author: Alan Modra <amodra@gmail.com>
Date:   Fri Feb 20 15:23:28 2015 +1030

    Fix localplt test breakage with new readelf
    
    Since 2014-11-24 binutils git commit bb4d2ac2, readelf has appended
    the symbol version to symbols shown in reloc dumps.
    
    	[BZ #16512]
    	* scripts/localplt.awk: Strip off symbol version.
    	* NEWS: Mention bug fix.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=a274119b0e6b4800163d8d1870995e597a55cb8b

commit a274119b0e6b4800163d8d1870995e597a55cb8b
Author: Florian Weimer <fweimer@redhat.com>
Date:   Fri Aug 26 22:40:27 2016 +0200

    malloc: Simplify static malloc interposition [BZ #20432]
    
    Existing interposed mallocs do not define the glibc-internal
    fork callbacks (and they should not), so statically interposed
    mallocs lead to link failures because the strong reference from
    fork pulls in glibc's malloc, resulting in multiple definitions
    of malloc-related symbols.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=a18c25e0ee00bb37c724123d8b187050e9a367a0

commit a18c25e0ee00bb37c724123d8b187050e9a367a0
Author: Florian Weimer <fweimer@redhat.com>
Date:   Tue Aug 16 11:06:13 2016 +0200

    nptl/tst-tls3-malloc: Force freeing of thread stacks
    
    It turns out that due to the reduced stack size in tst-tls3 and the
    (fixed) default stack cache size, allocated TLS variables are never
    freed, so the test coverage for tst-tls3-malloc is less than complete.
    This change increases the thread stack size for tst-tls3-malloc only,
    to make sure thread stacks and TLS variables are freed.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=124ea50584d3d21fe4c2fe9383508efd0ac9010a

commit 124ea50584d3d21fe4c2fe9383508efd0ac9010a
Author: Florian Weimer <fweimer@redhat.com>
Date:   Tue Aug 2 17:01:02 2016 +0200

    malloc: Run tests without calling mallopt [BZ #19469]
    
    The compiled tests no longer refer to the mallopt symbol
    from their main functions.  (Some tests still call mallopt
    explicitly, which is fine.)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=5a8692a64640bb648de6be9877dc072d728859bd

commit 5a8692a64640bb648de6be9877dc072d728859bd
Author: Florian Weimer <fweimer@redhat.com>
Date:   Wed Aug 3 16:16:57 2016 +0200

    elf: Do not use memalign for TCB/TLS blocks allocation [BZ #17730]
    
    Instead, call malloc and explicitly align the pointer.
    
    There is no external location to store the original (unaligned)
    pointer, and this commit increases the allocation size to store
    the pointer at a fixed location relative to the TCB pointer.
    
    The manual alignment means that some space goes unused which
    was previously made available for subsequent allocations.
    However, in the TLS_DTV_AT_TP case, the manual alignment code
    avoids aligning the pre-TCB to the TLS block alignment.  (Even
    while using memalign, the allocation had some unused padding
    in front.)
    
    This concludes the removal of memalign calls from the TLS code,
    and the new tst-tls3-malloc test verifies that only core malloc
    routines are used.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=6a277a415c127f6ee9a70548c899a7ac536f4288

commit 6a277a415c127f6ee9a70548c899a7ac536f4288
Author: Florian Weimer <fweimer@redhat.com>
Date:   Wed Aug 3 16:15:38 2016 +0200

    elf: Avoid using memalign for TLS allocations [BZ #17730]
    
    Instead of a flag which indicates the pointer can be freed, dtv_t
    now includes the pointer which should be freed.  Due to padding,
    the size of dtv_t does not increase.
    
    To avoid using memalign, the new allocate_dtv_entry function
    allocates a sufficiently large buffer so that a sub-buffer
    can be found in it which starts with an aligned pointer.  Both
    the aligned and original pointers are kept, the latter for calling
    free later.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=9e1e8f68d59e33baa0eef9e8690d3cbaa5f67a24

commit 9e1e8f68d59e33baa0eef9e8690d3cbaa5f67a24
Author: Alexandre Oliva <aoliva@redhat.com>
Date:   Tue Mar 17 01:14:11 2015 -0300

    Fix DTV race, assert, DTV_SURPLUS Static TLS limit, and nptl_db garbage
    
    for  ChangeLog
    
    	[BZ #17090]
    	[BZ #17620]
    	[BZ #17621]
    	[BZ #17628]
    	* NEWS: Update.
    	* elf/dl-tls.c (_dl_update_slotinfo): Clean up outdated DTV
    	entries with Static TLS too.  Skip entries past the end of the
    	allocated DTV, from Alan Modra.
    	(tls_get_addr_tail): Update to glibc_likely/unlikely.  Move
    	Static TLS DTV entry set up from...
    	 (_dl_allocate_tls_init): ... here (fix modid assertion), ...
    	* elf/dl-reloc.c (_dl_nothread_init_static_tls): ... here...
    	* nptl/allocatestack.c (init_one_static_tls): ... and here...
    	* elf/dlopen.c (dl_open_worker): Drop l_tls_modid upper bound
    	for Static TLS.
    	* elf/tlsdeschtab.h (map_generation): Return size_t.  Check
    	that the slot we find is associated with the given map before
    	using its generation count.
    	* nptl_db/db_info.c: Include ldsodefs.h.
    	(rtld_global, dtv_slotinfo_list, dtv_slotinfo): New typedefs.
    	* nptl_db/structs.def (DB_RTLD_VARIABLE): New macro.
    	(DB_MAIN_VARIABLE, DB_RTLD_GLOBAL_FIELD): Likewise.
    	(link_map::l_tls_offset): New struct field.
    	(dtv_t::counter): Likewise.
    	(rtld_global): New struct.
    	(_rtld_global): New rtld variable.
    	(dl_tls_dtv_slotinfo_list): New rtld global field.
    	(dtv_slotinfo_list): New struct.
    	(dtv_slotinfo): Likewise.
    	* nptl_db/td_symbol_list.c: Drop gnu/lib-names.h include.
    	(td_lookup): Rename to...
    	(td_mod_lookup): ... this.  Use new mod parameter instead of
    	LIBPTHREAD_SO.
    	* nptl_db/td_thr_tlsbase.c: Include link.h.
    	(dtv_slotinfo_list, dtv_slotinfo): New functions.
    	(td_thr_tlsbase): Check DTV generation.  Compute Static TLS
    	addresses even if the DTV is out of date or missing them.
    	* nptl_db/fetch-value.c (_td_locate_field): Do not refuse to
    	index zero-length arrays.
    	* nptl_db/thread_dbP.h: Include gnu/lib-names.h.
    	(td_lookup): Make it a macro implemented in terms of...
    	(td_mod_lookup): ... this declaration.
    	* nptl_db/db-symbols.awk (DB_RTLD_VARIABLE): Override.
    	(DB_MAIN_VARIABLE): Likewise.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=dd08634b37f81f01441d842087b123d12b4003d4

commit dd08634b37f81f01441d842087b123d12b4003d4
Author: Florian Weimer <fweimer@redhat.com>
Date:   Mon Jun 20 14:31:40 2016 +0200

    elf: Consolidate machine-agnostic DTV definitions in <dl-dtv.h>
    
    Identical definitions of dtv_t and TLS_DTV_UNALLOCATED were
    repeated for all architectures using DTVs.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=749c94d44c9aa063dfc7ad2b505c8e6d35e57345

commit 749c94d44c9aa063dfc7ad2b505c8e6d35e57345
Author: Florian Weimer <fweimer@redhat.com>
Date:   Thu Apr 14 09:17:02 2016 +0200

    malloc: Run fork handler as late as possible [BZ #19431]
    
    Previously, a thread M invoking fork would acquire locks in this order:
    
      (M1) malloc arena locks (in the registered fork handler)
      (M2) libio list lock
    
    A thread F invoking flush (NULL) would acquire locks in this order:
    
      (F1) libio list lock
      (F2) individual _IO_FILE locks
    
    A thread G running getdelim would use this order:
    
      (G1) _IO_FILE lock
      (G2) malloc arena lock
    
    After executing (M1), (F1), (G1), none of the threads can make progress.
    
    This commit changes the fork lock order to:
    
      (M'1) libio list lock
      (M'2) malloc arena locks
    
    It explicitly encodes the lock order in the implementations of fork,
    and does not rely on the registration order, thus avoiding the deadlock.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=b533edfeedf66e971b1b29affd8e2f1619987dc9

commit b533edfeedf66e971b1b29affd8e2f1619987dc9
Author: Florian Weimer <fweimer@redhat.com>
Date:   Mon Dec 21 16:42:46 2015 +0100

    malloc: Fix list_lock/arena lock deadlock [BZ #19182]
    
    	* malloc/arena.c (list_lock): Document lock ordering requirements.
    	(free_list_lock): New lock.
    	(ptmalloc_lock_all): Comment on free_list_lock.
    	(ptmalloc_unlock_all2): Reinitialize free_list_lock.
    	(detach_arena): Update comment.  free_list_lock is now needed.
    	(_int_new_arena): Use free_list_lock around detach_arena call.
    	Acquire arena lock after list_lock.  Add comment, including FIXME
    	about incorrect synchronization.
    	(get_free_list): Switch to free_list_lock.
    	(reused_arena): Acquire free_list_lock around detach_arena call
    	and attached threads counter update.  Add two FIXMEs about
    	incorrect synchronization.
    	(arena_thread_freeres): Switch to free_list_lock.
    	* malloc/malloc.c (struct malloc_state): Update comments to
    	mention free_list_lock.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=4b31bd831ab205ff24ae3a2b8c4f8135c182c7d7

commit 4b31bd831ab205ff24ae3a2b8c4f8135c182c7d7
Author: Florian Weimer <fweimer@redhat.com>
Date:   Tue Nov 24 16:37:15 2015 +0100

    Replace MUTEX_INITIALIZER with _LIBC_LOCK_INITIALIZER in generic code
    
    	* sysdeps/mach/hurd/libc-lock.h (_LIBC_LOCK_INITIALIZER): Define.
    	(__libc_lock_define_initialized): Use it.
    	* sysdeps/nptl/libc-lockP.h (_LIBC_LOCK_INITIALIZER): Define.
    	* malloc/arena.c (list_lock): Use _LIBC_LOCK_INITIALIZER.
    	* malloc/malloc.c (main_arena): Likewise.
    	* sysdeps/generic/malloc-machine.h (MUTEX_INITIALIZER): Remove.
    	* sysdeps/nptl/malloc-machine.h (MUTEX_INITIALIZER): Remove.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=50992336ac40625c363e1514890f92774c65054a

commit 50992336ac40625c363e1514890f92774c65054a
Author: Florian Weimer <fweimer@redhat.com>
Date:   Wed Oct 28 19:32:46 2015 +0100

    malloc: Prevent arena free_list from turning cyclic [BZ #19048]
    
    	[BZ# 19048]
    	* malloc/malloc.c (struct malloc_state): Update comment.  Add
    	attached_threads member.
    	(main_arena): Initialize attached_threads.
    	* malloc/arena.c (list_lock): Update comment.
    	(ptmalloc_lock_all, ptmalloc_unlock_all): Likewise.
    	(ptmalloc_unlock_all2): Reinitialize arena reference counts.
    	(deattach_arena): New function.
    	(_int_new_arena): Initialize arena reference count and deattach
    	replaced arena.
    	(get_free_list, reused_arena): Update reference count and deattach
    	replaced arena.
    	(arena_thread_freeres): Update arena reference count and only put
    	unreferenced arenas on the free list.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=39ad1d12448adf0682ffb8b8ac146e99b68279bf

commit 39ad1d12448adf0682ffb8b8ac146e99b68279bf
Author: Florian Weimer <fweimer@redhat.com>
Date:   Sat Oct 17 12:06:48 2015 +0200

    malloc: Rewrite with explicit TLS access using __thread

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=7f2efd6c269a2ab2eee80bffa5bcb2538aa89641

commit 7f2efd6c269a2ab2eee80bffa5bcb2538aa89641
Author: Siddhesh Poyarekar <siddhesh@redhat.com>
Date:   Wed Feb 18 11:06:05 2015 +0530

    Consolidate arena_lookup and arena_lock into a single arena_get
    
    This seems to have been left behind as an artifact of some old changes
    and can now be merged.  Verified that the only generated code change
    on x86_64 is that of line numbers in asserts, like so:
    
    @@ -27253,7 +27253,7 @@ Disassembly of section .text:
       416f09:      48 89 42 20             mov    %rax,0x20(%rdx)
       416f0d:      e9 7e f6 ff ff          jmpq   416590 <_int_free+0x230>
       416f12:      b9 3f 9f 4a 00          mov    $0x4a9f3f,%ecx
    -  416f17:      ba d5 0f 00 00          mov    $0xfd5,%edx
    +  416f17:      ba d6 0f 00 00          mov    $0xfd6,%edx
       416f1c:      be a8 9b 4a 00          mov    $0x4a9ba8,%esi
       416f21:      bf 6a 9c 4a 00          mov    $0x4a9c6a,%edi
       416f26:      e8 45 e8 ff ff          callq  415770 <__malloc_assert>

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog                                  |  298 ++++++++++++++++++++++++++++
 NEWS                                       |    4 +-
 csu/libc-tls.c                             |    2 +-
 elf/dl-open.c                              |   12 +-
 elf/dl-reloc.c                             |    6 -
 elf/dl-tls.c                               |  209 ++++++++++++--------
 elf/tlsdeschtab.h                          |    4 +-
 include/libc-symbols.h                     |   15 ++
 malloc/Makefile                            |   33 +++-
 malloc/arena.c                             |  211 +++++++++++++-------
 malloc/malloc-internal.h                   |   32 +++
 malloc/malloc.c                            |   20 ++-
 malloc/tst-interpose-aux-nothread.c        |   20 ++
 malloc/tst-interpose-aux-thread.c          |   20 ++
 malloc/tst-interpose-aux.c                 |  270 +++++++++++++++++++++++++
 malloc/tst-interpose-aux.h                 |   30 +++
 malloc/tst-interpose-nothread.c            |   20 ++
 malloc/tst-interpose-skeleton.c            |  210 ++++++++++++++++++++
 malloc/tst-interpose-static-nothread.c     |   19 ++
 malloc/tst-interpose-static-thread.c       |   19 ++
 malloc/tst-interpose-thread.c              |   20 ++
 malloc/tst-malloc-fork-deadlock.c          |  220 ++++++++++++++++++++
 manual/memory.texi                         |   12 --
 nptl/Makefile                              |    8 +-
 nptl/allocatestack.c                       |   13 +-
 nptl/tst-tls3-malloc.c                     |   31 +++
 nptl/tst-tls3.c                            |   10 +-
 nptl_db/db-symbols.awk                     |    2 +
 nptl_db/db_info.c                          |    4 +
 nptl_db/fetch-value.c                      |    3 +-
 nptl_db/structs.def                        |   39 ++++
 nptl_db/td_symbol_list.c                   |    7 +-
 nptl_db/td_thr_tlsbase.c                   |  172 ++++++++++++++++-
 nptl_db/thread_dbP.h                       |   11 +-
 scripts/check-localplt.awk                 |   40 ++++-
 scripts/localplt.awk                       |   51 +++++-
 sysdeps/aarch64/dl-tls.h                   |    3 -
 sysdeps/aarch64/nptl/tls.h                 |   12 +-
 sysdeps/alpha/dl-tls.h                     |    3 -
 sysdeps/alpha/nptl/tls.h                   |   12 +-
 sysdeps/arm/dl-tls.h                       |    3 -
 sysdeps/arm/nptl/tls.h                     |   12 +-
 sysdeps/generic/dl-dtv.h                   |   38 ++++
 sysdeps/generic/malloc-machine.h           |    8 -
 sysdeps/hppa/dl-tls.h                      |    3 -
 sysdeps/hppa/nptl/tls.h                    |   12 +-
 sysdeps/i386/dl-tls.h                      |    3 -
 sysdeps/i386/nptl/tls.h                    |   14 +--
 sysdeps/ia64/dl-tls.h                      |    3 -
 sysdeps/ia64/nptl/tls.h                    |   14 +--
 sysdeps/m68k/dl-tls.h                      |    3 -
 sysdeps/m68k/nptl/tls.h                    |   12 +-
 sysdeps/mach/hurd/bits/libc-lock.h         |    3 +-
 sysdeps/mach/hurd/fork.c                   |   13 ++
 sysdeps/mach/hurd/i386/tls.h               |   12 +-
 sysdeps/mach/hurd/malloc-machine.h         |   10 -
 sysdeps/microblaze/dl-tls.h                |    3 -
 sysdeps/microblaze/nptl/tls.h              |   12 +-
 sysdeps/mips/dl-tls.h                      |    3 -
 sysdeps/mips/nptl/tls.h                    |   13 +-
 sysdeps/nios2/dl-tls.h                     |    3 -
 sysdeps/nios2/nptl/tls.h                   |   12 +-
 sysdeps/nptl/bits/libc-lockP.h             |    1 +
 sysdeps/nptl/fork.c                        |   14 ++-
 sysdeps/nptl/malloc-machine.h              |   11 -
 sysdeps/powerpc/dl-tls.h                   |    3 -
 sysdeps/powerpc/nptl/tls.h                 |   12 +-
 sysdeps/s390/dl-tls.h                      |    3 -
 sysdeps/s390/nptl/tls.h                    |   14 +--
 sysdeps/sh/dl-tls.h                        |    3 -
 sysdeps/sh/nptl/tls.h                      |   12 +-
 sysdeps/sparc/dl-tls.h                     |    3 -
 sysdeps/sparc/nptl/tls.h                   |   12 +-
 sysdeps/tile/dl-tls.h                      |    3 -
 sysdeps/tile/nptl/tls.h                    |   12 +-
 sysdeps/unix/sysv/linux/i386/localplt.data |    8 +-
 sysdeps/x86_64/dl-tls.h                    |    3 -
 sysdeps/x86_64/localplt.data               |   19 ++
 sysdeps/x86_64/nptl/tls.h                  |   13 +--
 test-skeleton.c                            |    2 +
 80 files changed, 1979 insertions(+), 505 deletions(-)
 create mode 100644 malloc/malloc-internal.h
 create mode 100644 malloc/tst-interpose-aux-nothread.c
 create mode 100644 malloc/tst-interpose-aux-thread.c
 create mode 100644 malloc/tst-interpose-aux.c
 create mode 100644 malloc/tst-interpose-aux.h
 create mode 100644 malloc/tst-interpose-nothread.c
 create mode 100644 malloc/tst-interpose-skeleton.c
 create mode 100644 malloc/tst-interpose-static-nothread.c
 create mode 100644 malloc/tst-interpose-static-thread.c
 create mode 100644 malloc/tst-interpose-thread.c
 create mode 100644 malloc/tst-malloc-fork-deadlock.c
 create mode 100644 nptl/tst-tls3-malloc.c
 create mode 100644 sysdeps/generic/dl-dtv.h
 create mode 100644 sysdeps/x86_64/localplt.data
Comment 10 cvs-commit@gcc.gnu.org 2017-02-05 15:59:30 UTC
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The annotated tag, glibc-2.25 has been created
        at  be176490b818b65b5162c332eb6b581690b16e5c (tag)
   tagging  db0242e3023436757bbc7c488a779e6e3343db04 (commit)
  replaces  glibc-2.24
 tagged by  Siddhesh Poyarekar
        on  Sun Feb 5 21:19:00 2017 +0530

- Log -----------------------------------------------------------------
The GNU C Library
=================

The GNU C Library version 2.25 is now available.

The GNU C Library is used as *the* C library in the GNU system and
in GNU/Linux systems, as well as many other systems that use Linux
as the kernel.

The GNU C Library is primarily designed to be a portable
and high performance C library.  It follows all relevant
standards including ISO C11 and POSIX.1-2008.  It is also
internationalized and has one of the most complete
internationalization interfaces known.

The GNU C Library webpage is at http://www.gnu.org/software/libc/

Packages for the 2.25 release may be downloaded from:
        http://ftpmirror.gnu.org/libc/
        http://ftp.gnu.org/gnu/libc/

The mirror list is at http://www.gnu.org/order/ftp.html

NEWS for version 2.25
=====================

* The feature test macro __STDC_WANT_LIB_EXT2__, from ISO/IEC TR
  24731-2:2010, is supported to enable declarations of functions from that
  TR.  Note that not all functions from that TR are supported by the GNU C
  Library.

* The feature test macro __STDC_WANT_IEC_60559_BFP_EXT__, from ISO/IEC TS
  18661-1:2014, is supported to enable declarations of functions and macros
  from that TS.  Note that not all features from that TS are supported by
  the GNU C Library.

* The feature test macro __STDC_WANT_IEC_60559_FUNCS_EXT__, from ISO/IEC TS
  18661-4:2015, is supported to enable declarations of functions and macros
  from that TS.  Note that most features from that TS are not supported by
  the GNU C Library.

* The nonstandard feature selection macros _REENTRANT and _THREAD_SAFE are
  now treated as compatibility synonyms for _POSIX_C_SOURCE=199506L.
  Since the GNU C Library defaults to a much newer revision of POSIX, this
  will only affect programs that specifically request an old conformance
  mode.  For instance, a program compiled with -std=c89 -D_REENTRANT will
  see a change in the visible declarations, but a program compiled with
  just -D_REENTRANT, or -std=c99 -D_POSIX_C_SOURCE=200809L -D_REENTRANT,
  will not.

  Some C libraries once required _REENTRANT and/or _THREAD_SAFE to be
  defined by all multithreaded code, but glibc has not required this for
  many years.

* The inclusion of <sys/sysmacros.h> by <sys/types.h> is deprecated.  This
  means that in a future release, the macros “major”, “minor”, and “makedev”
  will only be available from <sys/sysmacros.h>.

  These macros are not part of POSIX nor XSI, and their names frequently
  collide with user code; see for instance glibc bug 19239 and Red Hat bug
  130601.  <stdlib.h> includes <sys/types.h> under _GNU_SOURCE, and C++ code
  presently cannot avoid being compiled under _GNU_SOURCE, exacerbating the
  problem.

* New <fenv.h> features from TS 18661-1:2014 are added to libm: the
  fesetexcept, fetestexceptflag, fegetmode and fesetmode functions, the
  femode_t type and the FE_DFL_MODE and FE_SNANS_ALWAYS_SIGNAL macros.

* Integer width macros from TS 18661-1:2014 are added to <limits.h>:
  CHAR_WIDTH, SCHAR_WIDTH, UCHAR_WIDTH, SHRT_WIDTH, USHRT_WIDTH, INT_WIDTH,
  UINT_WIDTH, LONG_WIDTH, ULONG_WIDTH, LLONG_WIDTH, ULLONG_WIDTH; and to
  <stdint.h>: INT8_WIDTH, UINT8_WIDTH, INT16_WIDTH, UINT16_WIDTH,
  INT32_WIDTH, UINT32_WIDTH, INT64_WIDTH, UINT64_WIDTH, INT_LEAST8_WIDTH,
  UINT_LEAST8_WIDTH, INT_LEAST16_WIDTH, UINT_LEAST16_WIDTH,
  INT_LEAST32_WIDTH, UINT_LEAST32_WIDTH, INT_LEAST64_WIDTH,
  UINT_LEAST64_WIDTH, INT_FAST8_WIDTH, UINT_FAST8_WIDTH, INT_FAST16_WIDTH,
  UINT_FAST16_WIDTH, INT_FAST32_WIDTH, UINT_FAST32_WIDTH, INT_FAST64_WIDTH,
  UINT_FAST64_WIDTH, INTPTR_WIDTH, UINTPTR_WIDTH, INTMAX_WIDTH,
  UINTMAX_WIDTH, PTRDIFF_WIDTH, SIG_ATOMIC_WIDTH, SIZE_WIDTH, WCHAR_WIDTH,
  WINT_WIDTH.

* New <math.h> features are added from TS 18661-1:2014:

  - Signaling NaN macros: SNANF, SNAN, SNANL.

  - Nearest integer functions: roundeven, roundevenf, roundevenl, fromfp,
    fromfpf, fromfpl, ufromfp, ufromfpf, ufromfpl, fromfpx, fromfpxf,
    fromfpxl, ufromfpx, ufromfpxf, ufromfpxl.

  - llogb functions: the llogb, llogbf and llogbl functions, and the
    FP_LLOGB0 and FP_LLOGBNAN macros.

  - Max-min magnitude functions: fmaxmag, fmaxmagf, fmaxmagl, fminmag,
    fminmagf, fminmagl.

  - Comparison macros: iseqsig.

  - Classification macros: iscanonical, issubnormal, iszero.

  - Total order functions: totalorder, totalorderf, totalorderl,
    totalordermag, totalordermagf, totalordermagl.

  - Canonicalize functions: canonicalize, canonicalizef, canonicalizel.

  - NaN functions: getpayload, getpayloadf, getpayloadl, setpayload,
    setpayloadf, setpayloadl, setpayloadsig, setpayloadsigf, setpayloadsigl.

* The functions strfromd, strfromf, and strfroml, from ISO/IEC TS 18661-1:2014,
  are added to libc.  They convert a floating-point number into string.

* Most of glibc can now be built with the stack smashing protector enabled.
  It is recommended to build glibc with --enable-stack-protector=strong.
  Implemented by Nick Alcock (Oracle).

* The function explicit_bzero, from OpenBSD, has been added to libc.  It is
  intended to be used instead of memset() to erase sensitive data after use;
  the compiler will not optimize out calls to explicit_bzero even if they
  are "unnecessary" (in the sense that no _correct_ program can observe the
  effects of the memory clear).

* On ColdFire, MicroBlaze, Nios II and SH3, the float_t type is now defined
  to float instead of double.  This does not affect the ABI of any libraries
  that are part of the GNU C Library, but may affect the ABI of other
  libraries that use this type in their interfaces.

* On x86_64, when compiling with -mfpmath=387 or -mfpmath=sse+387, the
  float_t and double_t types are now defined to long double instead of float
  and double.  These options are not the default, and this does not affect
  the ABI of any libraries that are part of the GNU C Library, but it may
  affect the ABI of other libraries that use this type in their interfaces,
  if they are compiled or used with those options.

* The getentropy and getrandom functions, and the <sys/random.h> header file
  have been added.

* The buffer size for byte-oriented stdio streams is now limited to 8192
  bytes by default.  Previously, on Linux, the default buffer size on most
  file systems was 4096 bytes (and thus remains unchanged), except on
  network file systems, where the buffer size was unpredictable and could be
  as large as several megabytes.

* The <sys/quota.h> header now includes the <linux/quota.h> header.  Support
  for the Linux quota interface which predates kernel version 2.4.22 has
  been removed.

* The malloc_get_state and malloc_set_state functions have been removed.
  Already-existing binaries that dynamically link to these functions will
  get a hidden implementation in which malloc_get_state is a stub.  As far
  as we know, these functions are used only by GNU Emacs and this change
  will not adversely affect already-built Emacs executables.  Any undumped
  Emacs executables, which normally exist only during an Emacs build, should
  be rebuilt by re-running “./configure; make” in the Emacs build tree.

* The “ip6-dotint” and “no-ip6-dotint” resolver options, and the
  corresponding RES_NOIP6DOTINT flag from <resolv.h> have been removed.
  “no-ip6-dotint” had already been the default, and support for the
  “ip6-dotint” option was removed from the Internet in 2006.

* The "ip6-bytestring" resolver option and the corresponding RES_USEBSTRING
  flag from <resolv.h> have been removed.  The option relied on a
  backwards-incompatible DNS extension which was never deployed on the
  Internet.

* The flags RES_AAONLY, RES_PRIMARY, RES_NOCHECKNAME, RES_KEEPTSIG,
  RES_BLAST defined in the <resolv.h> header file have been deprecated.
  They were already unimplemented.

* The "inet6" option in /etc/resolv.conf and the RES_USE_INET6 flag for
  _res.flags are deprecated.  The flag was standardized in RFC 2133, but
  removed again from the IETF name lookup interface specification in RFC
  2553.  Applications should use getaddrinfo instead.

* DNSSEC-related declarations and definitions have been removed from the
  <arpa/nameser.h> header file, and libresolv will no longer attempt to
  decode the data part of DNSSEC record types.  Previous versions of glibc
  only implemented minimal support for the previous version of DNSSEC, which
  is incompatible with the currently deployed version.

* The resource record type classification macros ns_t_qt_p, ns_t_mrr_p,
  ns_t_rr_p, ns_t_udp_p, ns_t_xfr_p have been removed from the
  <arpa/nameser.h> header file because the distinction between RR types and
  meta-RR types is not officially standardized, subject to revision, and
  thus not suitable for encoding in a macro.

* The types res_sendhookact, res_send_qhook, re_send_rhook, and the qhook
  and rhook members of the res_state type in <resolv.h> have been removed.
  The glibc stub resolver did not support these hooks, but the header file
  did not reflect that.

* For multi-arch support it is recommended to use a GCC which has
  been built with support for GNU indirect functions.  This ensures
  that correct debugging information is generated for functions
  selected by IFUNC resolvers.  This support can either be enabled by
  configuring GCC with '--enable-gnu-indirect-function', or by
  enabling it by default by setting 'default_gnu_indirect_function'
  variable for a particular architecture in the GCC source file
  'gcc/config.gcc'.

* GDB pretty printers have been added for mutex and condition variable
  structures in POSIX Threads. When installed and loaded in gdb these pretty
  printers show various pthread variables in human-readable form when read
  using the 'print' or 'display' commands in gdb.

* Tunables feature added to allow tweaking of the runtime for an application
  program.  This feature can be enabled with the '--enable-tunables' configure
  flag.  The GNU C Library manual has details on usage and README.tunables has
  instructions on adding new tunables to the library.

* A new version of condition variables functions have been implemented in
  the NPTL implementation of POSIX Threads to provide stronger ordering
  guarantees.

* A new version of pthread_rwlock functions have been implemented to use a more
  scalable algorithm primarily through not using a critical section anymore to
  make state changes.

Security related changes:

* On ARM EABI (32-bit), generating a backtrace for execution contexts which
  have been created with makecontext could fail to terminate due to a
  missing .cantunwind annotation.  This has been observed to lead to a hang
  (denial of service) in some Go applications compiled with gccgo.  Reported
  by Andreas Schwab.  (CVE-2016-6323)

* The DNS stub resolver functions would crash due to a NULL pointer
  dereference when processing a query with a valid DNS question type which
  was used internally in the implementation.  The stub resolver now uses a
  question type which is outside the range of valid question type values.
  (CVE-2015-5180)

Contributors
============

This release was made possible by the contributions of many people.
The maintainers are grateful to everyone who has contributed
changes or bug reports.  These include:

Adhemerval Zanella
Alan Modra
Alexandre Oliva
Andreas Schwab
Andrew Senkevich
Aurelien Jarno
Brent W. Baccala
Carlos O'Donell
Chris Metcalf
Chung-Lin Tang
DJ Delorie
David S. Miller
Denis Kaganovich
Dmitry V. Levin
Ernestas Kulik
Florian Weimer
Gabriel F T Gomes
Gabriel F. T. Gomes
H.J. Lu
Jakub Jelinek
James Clarke
James Greenhalgh
Jim Meyering
John David Anglin
Joseph Myers
Maciej W. Rozycki
Mark Wielaard
Martin Galvan
Martin Pitt
Mike Frysinger
Märt Põder
Nick Alcock
Paul E. Murphy
Paul Murphy
Rajalakshmi Srinivasaraghavan
Rasmus Villemoes
Rical Jasan
Richard Henderson
Roland McGrath
Samuel Thibault
Siddhesh Poyarekar
Stefan Liebler
Steve Ellcey
Svante Signell
Szabolcs Nagy
Tom Tromey
Torvald Riegel
Tulio Magno Quites Machado Filho
Wilco Dijkstra
Yury Norov
Zack Weinberg
-----BEGIN PGP SIGNATURE-----

iQEcBAABAgAGBQJYl0mTAAoJEHnEPfvxzyGHXTgH/jsS205Wdz9EniZrJ6+NXCm1
F/eeOMotGNv82BYaLRnw9XrF7p6+ND8E+7rSvFZT5O309OrdLjg4QG6M63COMRCh
6KKtQUM/00I1u4AYkOOgrUkor3m58GgeQUziOxXNvQNoU8zLguPk4kzVsvxq6lJR
/IROH2Mfl1AggOGq9Y1R/0uQCpj4jJSLETxJupg4calGPZQW3isogucSmogdccAB
Bqso7L40Xo4LJnEoD7JurlMrP5x043TttmTyvnFTtxRZTAHVjyQpFMKHaSkMgtIG
+fe26Ua3oMqbE9A9G3qiMIrPEqu+0tWKbvci0FeaE30vfI6YtVcd8I0RlBW9gok=
=3NM3
-----END PGP SIGNATURE-----

Adhemerval Zanella (69):
      Fix test-skeleton C99 designed initialization
      nptl: Consolidate sem_open implementations
      nptl: Set sem_open as a non cancellation point (BZ #15765)
      nptl: Remove sparc sem_wait
      nptl: Fix sem_wait and sem_timedwait cancellation (BZ#18243)
      rt: Set shm_open as a non cancellation point (BZ #18243)
      nptl: Consolidate sem_init implementations
      posix: Correctly enable/disable cancellation on Linux posix_spawn
      posix: Correctly block/unblock all signals on Linux posix_spawn
      Add INTERNAL_SYSCALL_CALL
      posix: Fix open file action for posix_spawn on Linux
      Remove C++ style comments from string3.h
      libio: Multiple fixes for open_{w}memstram (BZ#18241 and BZ#20181)
      Fix tst-memstream3 build failure
      Consolidate fallocate{64} implementations
      Consolidate posix_fallocate{64} implementations
      Consolidate posix_fadvise implementations
      Fix iseqsig for ports that do not support FE_INVALID
      Consolidate Linux sync_file_range implementations
      Fix posix_fadvise64 build on mips64n64
      Fix Linux fallocate tests for EOPNOTSUPP
      Fix Linux sh4 pread/pwrite argument passing
      Fix sparc build due missing __WORDSIZE_TIME64_COMPAT32 definition
      Consolidate lseek/lseek64/llseek implementations
      Consolidate Linux ftruncate implementations
      Consolidate Linux truncate implementations
      Consolidate Linux access implementation
      Fix sh4 build with __ASSUME_ST_INO_64_BIT redefinition
      New internal function __access_noerrno
      Consolidate Linux setrlimit and getrlimit implementation
      Fix hurd __access_noerrno implementation.
      Fix writes past the allocated array bounds in execvpe (BZ#20847)
      Remove cached PID/TID in clone
      powerpc: Remove stpcpy internal clash with IFUNC
      powerpc: Remove stpcpy internal clash with IFUNC
      Fix writes past the allocated array bounds in execvpe (BZ#20847)
      Consolidate rename Linux implementation
      Consolidate renameat Linux implementation
      Fix powerpc64/power7 memchr for large input sizes
      Fix typos and missing closing bracket in test-memchr.c
      Adjust benchtests to new support library.
      benchtests: Add fmax/fmin benchmarks
      benchtests: Add fmaxf/fminf benchmarks
      Fix x86_64 memchr for large input sizes
      powerpc: Remove f{max,min}{f} assembly implementations
      Add __ASSUME_DIRECT_SYSVIPC_SYSCALL for Linux
      Refactor Linux ipc_priv header
      Consolidate Linux msgctl implementation
      Consolidate Linux msgrcv implementation
      Use msgsnd syscall for Linux implementation
      Use msgget syscall for Linux implementation
      Add SYSV message queue test
      Consolidate Linux semctl implementation
      Use semget syscall for Linux implementation
      Use semop syscall for Linux implementation
      Consolidate Linux semtimedop implementation
      Add SYSV semaphore test
      Use shmat syscall for Linux implementation
      Consolidate Linux shmctl implementation
      Use shmdt syscall for linux implementation
      Use shmget syscall for linux implementation
      Add SYSV shared memory test
      Fix i686 memchr for large input sizes
      Fix test-sysvsem on some platforms
      Fix x86 strncat optimized implementation for large sizes
      Remove duplicate strcat implementations
      Use fortify macros for b{zero,copy} along decl from strings.h
      Move fortified explicit_bzero back to string3
      Add missing bugzilla reference in previous ChangeLog entry

Alan Modra (1):
      powerpc32: make PLT call in _mcount compatible with -msecure-plt (bug 20554)

Alexandre Oliva (2):
      [PR19826] fix non-LE TLS in static programs
      Bug 20915: Do not initialize DTV of other threads.

Andreas Schwab (11):
      arm: mark __startcontext as .cantunwind (bug 20435)
      Properly initialize glob structure with GLOB_BRACE|GLOB_DOOFFS (bug 20707)
      Fix multiple definitions of mk[o]stemp[s]64
      Get rid of __elision_available
      Fix testsuite timeout handling
      powerpc: remove _dl_platform_string and _dl_powerpc_platforms
      Fix assertion failure on test timeout
      Fix ChangeLog typo
      Revert "Fix ChangeLog typo"
      m68k: fix 64bit atomic ops
      Fix missing test dependency

Andrew Senkevich (4):
      x86_64: Call finite scalar versions in vectorized log, pow, exp (bz #20033).
      Install libm.a as linker script (bug 20539).
      Better design of libm.a installation rule.
      Disable TSX on some Haswell processors.

Aurelien Jarno (14):
      alpha: fix ceil on sNaN input
      alpha: fix floor on sNaN input
      alpha: fix rint on sNaN input
      alpha: fix trunc for big input values
      powerpc: fix ifunc-sel.h with GCC 6
      powerpc: fix ifunc-sel.h fix asm constraints and clobber list
      sparc64: add a VIS3 version of ceil, floor and trunc
      sparc: build with -mvis on sparc32/sparcv9 and sparc64
      sparc: remove fdim sparc specific implementations
      sparc32/sparcv9: add a VIS3 version of fdim
      Set NODELETE flag after checking for NULL pointer
      conform tests: call perl with '-I.'
      gconv.h: fix build with GCC 7
      x86_64: fix static build of __memcpy_chk for compilers defaulting to PIC/PIE

Brent W. Baccala (1):
      hurd: Fix spurious port deallocation

Carlos O'Donell (17):
      Open development for 2.25.
      Update PO files.
      Bug 20292 - Simplify and test _dl_addr_inside_object
      Bug 20689: Fix FMA and AVX2 detection on Intel
      Fix atomic_fetch_xor_release.
      Add missing include for stdlib.h.
      Fix building tst-linkall-static.
      Add include/crypt.h.
      Bug 20729: Fix building with -Os.
      Bug 20729: Include libc-internal.h where required.
      Bug 20729: Fix build failures on ppc64 and other arches.
      Remove out of date PROJECTS file.
      Bug 20918 - Building with --enable-nss-crypt fails tst-linkall-static
      Bug 11941: ld.so: Improper assert map->l_init_called in dlclose
      Add deferred cancellation regression test for getpwuid_r.
      Fix failing pretty printer tests when CPPFLAGS has optimizations.
      Bug 20116: Fix use after free in pthread_create()

Chris Metcalf (6):
      Make sure tilepro uses kernel atomics fo atomic_store
      Make tile's set_dataplane API compatibility-only
      tile: create new math-tests.h header
      build-many-glibcs: Revert -fno-isolate-erroneous-paths options for tilepro
      tile: pass __IPC_64 as zero for SysV IPC calls
      tile: Check for pointer add overflow in memchr

Chung-Lin Tang (1):
      Add ipc_priv.h header for Nios II to set __IPC_64 to zero.

DJ Delorie (1):
      * elf/dl-tunables.c (tunable_set_val_if_valid_range): Split into ...

David S. Miller (4):
      Fix wide-char testsuite SIGBUS on platforms such as Sparc.
      Fix sNaN handling in nearbyint on 32-bit sparc.
      Fix a sparc header conformtest failure.
      sparc: Remove optimized math routines which cause testsuite failures.

Denis Kaganovich (1):
      configure: accept __stack_chk_fail_local for ssp support too [BZ #20662]

Dmitry V. Levin (1):
      Fix typos in the spelling of "implementation"

Ernestas Kulik (1):
      localedata: lt_LT: use hyphens in d_fmt [BZ #20497]

Florian Weimer (100):
      malloc: Preserve arena free list/thread count invariant [BZ #20370]
      malloc: Run tests without calling mallopt [BZ #19469]
      Add support for referencing specific symbol versions
      elf: dl-minimal malloc needs to respect fundamental alignment
      elf: Avoid using memalign for TLS allocations [BZ #17730]
      elf: Do not use memalign for TCB/TLS blocks allocation [BZ #17730]
      x86: Use sysdep.o from libc.a in static libraries
      Add missing reference to bug 20452
      nptl/tst-tls3-malloc: Force freeing of thread stacks
      Add NEWS entry for CVE-2016-6323
      Add CVE-2016-6323 missing from NEWS entry
      Do not override objects in libc.a in other static libraries [BZ #20452]
      nptl/tst-once5: Reduce time to expected failure
      argp: Do not override GCC keywords with macros [BZ #16907]
      string: More tests for strcmp, strcasecmp, strncmp, strncasecmp
      nptl: Avoid expected SIGALRM in most tests [BZ #20432]
      Correct incorrect bug number in changelog
      malloc: Simplify static malloc interposition [BZ #20432]
      Base <sys/quota.h> on Linux kernel headers [BZ #20525]
      vfprintf: Avoid creating a VLA which complicates stack management
      vfscanf: Avoid multiple reads of multi-byte character width
      malloc: Automated part of conversion to __libc_lock
      resolv: Remove _LIBC_REENTRANT
      Remove the ptw-% patterns
      inet: Add __inet6_scopeid_pton function [BZ #20611]
      sysd-rules: Cut down the number of rtld-% pattern rules
      Remove remnants of .og patterns
      sln: Preprocessor cleanups
      Generate .op pattern rules for profiling builds only
      Avoid running $(CXX) during build to obtain header file paths
      Add test case for O_TMPFILE handling in open, openat
      manual: Clarify the documentation of strverscmp [BZ #20524]
      Remove obsolete DNSSEC support [BZ #20591]
      resolv: Remove the BIND_4_COMPAT macro
      <arpa/nameser.h>, <arpa/nameser_compat.h>: Remove versions
      <arpa/nameser.h>: Remove RR type classification macros [BZ #20592]
      malloc: Manual part of conversion to __libc_lock
      resolv: Remove unsupported hook functions from the API [BZ #20016]
      test-skeleton.c: Remove unintended #include <stdarg.h>.
      tst-open-tmpfile: Add checks for open64, openat64, linkat
      manual: Clarify NSS error reporting
      resolv: Deprecate unimplemented flags
      resolv: Remove RES_NOIP6DOTINT and its implementation
      resolv: Remove RES_USEBSTRING and its implementation [BZ #20629]
      resolv: Compile without -Wno-write-strings
      math: Define iszero as a function template for C++ [BZ #20715]
      math.h: Wrap C++ bits in extern "C++"
      iconv: Avoid writable data and relocations in IBM charsets
      iconv: Avoid writable data and relocations in ISO646
      malloc: Remove malloc_get_state, malloc_set_state [BZ #19473]
      malloc: Use accessors for chunk metadata access
      sysmalloc: Initialize previous size field of mmaped chunks
      Add test for linking against most static libraries
      i386: Support CFLAGS which imply -fno-omit-frame-pointer [BZ #20729]
      crypt: Use internal names for the SHA-2 block functions
      malloc: Update comments about chunk layout
      nptl: Document the reason why __kind in pthread_mutex_t is part of the ABI
      s390x: Add hidden definition for __sigsetjmp
      elf: Assume TLS is initialized in _dl_map_object_from_fd
      powerpc: Remove unintended __longjmp symbol from ABI
      powerpc: Add hidden definition for __sigsetjmp
      gconv: Adjust GBK to support the Euro sign
      libio: Limit buffer size to 8192 bytes [BZ #4099]
      Implement _dl_catch_error, _dl_signal_error in libc.so [BZ #16628]
      ld.so: Remove __libc_memalign
      aarch64: Use explicit offsets in _dl_tlsdesc_dynamic
      elf/tst-tls-manydynamic: New test
      support: Introduce new subdirectory for test infrastructure
      inet: Make IN6_IS_ADDR_UNSPECIFIED etc. usable with POSIX [BZ #16421]
      debug: Additional compiler barriers for backtrace tests [BZ #20956]
      Add getentropy, getrandom, <sys/random.h> [BZ #17252]
      Expose linking against libsupport as make dependency
      nptl/tst-cancel7: Add missing case label
      Add missing bug number to ChangeLog
      Do not require memset elimination in explicit_bzero test
      Remove unused function _dl_tls_setup
      scripts/test_printers_common.py: Log GDB error message
      rpcinfo: Remove traces of unbuilt helper program
      sunrpc: Always obtain AF_INET addresses from NSS [BZ #20964]
      resolv: Remove processing of unimplemented "spoof" host.conf options
      Declare getentropy in <unistd.h> [BZ #17252]
      support: Add support for delayed test failure reporting
      Add file missing from ChangeLog in previous commit
      Fix various typos in the ChangeLog
      resolv: Turn historic name lookup functions into compat symbols
      getentropy: Declare it in <unistd.h> for __USE_MISC [BZ #17252]
      support: Helper functions for entering namespaces
      support: Use support_record_failure consistently
      support: Implement --verbose option for test programs
      resolv: Add beginnings of a libresolv test suite
      resolv: Deprecate the "inet6" option and RES_USE_INET6 [BZ #19582]
      resolv: Deprecate RES_BLAST
      tunables: Use correct unused attribute
      CVE-2015-5180: resolv: Fix crash with internal QTYPE [BZ #18784]
      Update DNS RR type definitions [BZ #20593]
      malloc: Run tunables tests only if tunables are enabled
      support: Use %td for pointer difference in xwrite
      support: struct netent portability fix for support_format_netent
      string/tst-strcoll-overflow: Do not accept timeout as test result
      nptl: Add tst-robust-fork

Gabriel F T Gomes (1):
      Fix warning caused by unused-result in bug-atexit3-lib.cc

Gabriel F. T. Gomes (10):
      Add strfromd, strfromf, and strfroml functions
      Use read_int in vfscanf
      Use write_message instead of write
      Write messages to stdout and use write_message instead of write
      Make w_log1p type-generic
      Fix arg used as litteral suffix in tst-strfrom.h
      Make w_scalbln type-generic
      Replace use of snprintf with strfrom in libm tests
      Fix typo in manual for iseqsig
      Move wrappers to libm-compat-calls-auto

H.J. Lu (8):
      X86: Change bit_YMM_state to (1 << 2)
      X86-64: Correct CFA in _dl_runtime_resolve
      X86-64: Add _dl_runtime_resolve_avx[512]_{opt|slow} [BZ #20508]
      X86: Don't assert on older Intel CPUs [BZ #20647]
      Check IFUNC definition in unrelocated shared library [BZ #20019]
      X86_64: Don't use PLT nor GOT in static archives [BZ #20750]
      Add VZEROUPPER to memset-vec-unaligned-erms.S [BZ #21081]
      Allow IFUNC relocation against unrelocated shared library

Jakub Jelinek (1):
      * soft-fp/op-common.h (_FP_MUL, _FP_FMA, _FP_DIV): Add

James Clarke (1):
      Bug 21053: sh: Reduce namespace pollution from sys/ucontext.h

James Greenhalgh (1):
      [soft-fp] Add support for various half-precision conversion routines.

Jim Meyering (1):
      assert.h: allow gcc to detect assert(a = 1) errors

John David Anglin (1):
      hppa: Optimize atomic_compare_and_exchange_val_acq

Joseph Myers (181):
      Support __STDC_WANT_LIB_EXT2__ feature test macro.
      Define PF_QIPCRTR, AF_QIPCRTR from Linux 4.7 in bits/socket.h.
      Define UDP_ENCAP_* from Linux 4.7 in netinet/udp.h.
      Support __STDC_WANT_IEC_60559_BFP_EXT__ feature test macro.
      Fix typo in last arith.texi change.
      Support __STDC_WANT_IEC_60559_FUNCS_EXT__ feature test macro.
      Also handle __STDC_WANT_IEC_60559_BFP_EXT__ in <tgmath.h>.
      Do not call __nan in scalb functions.
      Fix math.h comment about bits/mathdef.h.
      Add tests for fegetexceptflag, fesetexceptflag.
      Fix powerpc fesetexceptflag clearing FE_INVALID (bug 20455).
      Fix test-fexcept when "inexact" implicitly raised.
      Add comment from sysdeps/powerpc/fpu/fraiseexcpt.c to fsetexcptflg.c.
      Add fesetexcept.
      Add fesetexcept: aarch64.
      Add fesetexcept: alpha.
      Add fesetexcept: arm.
      Add fesetexcept: hppa.
      Add fesetexcept: ia64.
      Add fesetexcept: m68k.
      Add fesetexcept: mips.
      Add fesetexcept: powerpc.
      Add fesetexcept: s390.
      Add fesetexcept: sh.
      Add fesetexcept: sparc.
      Fix soft-fp extended.h unpacking (GCC bug 77265).
      Add fetestexceptflag.
      Add femode_t functions.
      Add femode_t functions: aarch64.
      Add femode_t functions: alpha.
      Add femode_t functions: arm.
      Add femode_t functions: hppa.
      Add femode_t functions: ia64.
      Add femode_t functions: m68k.
      Add femode_t functions: mips.
      Add femode_t functions: powerpc.
      Add femode_t functions: s390.
      Add femode_t functions: sh.
      Add femode_t functions: sparc.
      Add e500 version of fetestexceptflag.
      Add <limits.h> integer width macros.
      Add <stdint.h> integer width macros.
      Add issubnormal.
      Add iszero.
      Fix iszero for excess precision.
      Add iscanonical.
      Fix ldbl-128ibm iscanonical for -mlong-double-64.
      Use __builtin_fma more in dbl-64 code.
      Add TCP_REPAIR_WINDOW from Linux 4.8.
      Fix LONG_WIDTH, ULONG_WIDTH include ordering issue.
      Add iseqsig.
      Make iseqsig handle excess precision.
      Avoid M_NAN + M_NAN in complex functions.
      Add totalorder, totalorderf, totalorderl.
      Add more totalorder tests.
      Clean up some complex functions raising FE_INVALID.
      Add totalordermag, totalordermagf, totalordermagl.
      Define HIGH_ORDER_BIT_IS_SET_FOR_SNAN to 0 or 1.
      Add getpayload, getpayloadf, getpayloadl.
      Stop powerpc copysignl raising "invalid" for sNaN argument (bug 20718).
      Use VSQRT instruction for ARM sqrt (bug 20660).
      Use -fno-builtin for sqrt benchmark.
      Fix cmpli usage in power6 memset.
      Add getpayloadl to libnldbl.
      Add canonicalize, canonicalizef, canonicalizel.
      Make strtod raise "inexact" exceptions (bug 19380).
      Add SNAN, SNANF, SNANL macros.
      Correct clog10 documentation (bug 19673).
      Fix linknamespace parallel test failures.
      Handle tilegx* machine names.
      Add localplt.data for MIPS.
      XFAIL check-execstack for MIPS.
      Make MIPS <sys/user.h> self-contained.
      Do not hardcode platform names in manual/libm-err-tab.pl (bug 14139).
      Fix alpha sqrt fegetenv namespace (bug 20768).
      Handle tests-unsupported if run-built-tests = no.
      Do not generate UNRESOLVED results for run-built-tests = no.
      Make check-installed-headers.sh ignore sys/sysctl.h for x32.
      Update nios2 localplt.data.
      Update alpha localplt.data.
      Add localplt.data for hppa.
      Add localplt.data for sh.
      Fix rpcgen buffer overrun (bug 20790).
      Refactor some libm type-generic macros.
      Make SH <sys/user.h> self-contained.
      Ignore -Wmaybe-uninitialized in stdlib/bug-getcontext.c.
      Add script to build many glibc configurations.
      Make tilegx32 install libraries in lib32 directories.
      Fix build-many-glibcs.py style issues.
      Make SH ucontext always match current kernels.
      Fix SH4 register-dump.h for soft-float.
      Fix crypt snprintf namespace (bug 20829).
      Enable linknamespace testing for libdl and libcrypt.
      Make Alpha <sys/user.h> self-contained.
      Actually use newly built host libraries in build-many-glibcs.py.
      Quote shell commands in logs from build-many-glibcs.py.
      Add setpayload, setpayloadf, setpayloadl.
      Make build-many-glibcs.py use -fno-isolate-erroneous-paths options for tilepro.
      Fix default float_t definition (bug 20855).
      Fix x86_64 -mfpmath=387 float_t, double_t (bug 20787).
      Fix SH4 FP_ILOGB0 (bug 20859).
      More NEWS entries / fixes for float_t / double_t changes.
      Refactor float_t, double_t information into bits/flt-eval-method.h.
      Make build-many-glibcs.py track component versions requested and used.
      Add setpayloadsig, setpayloadsigf, setpayloadsigl.
      Make build-many-glibcs.py re-exec itself if changed by checkout.
      Make build-many-glibcs.py store more information about builds.
      Do not include asm/cachectl.h in nios2 sys/cachectl.h.
      Fix sysdeps/ia64/fpu/libm-symbols.h for inclusion in testcases.
      Work around IA64 tst-setcontext2.c compile failure.
      Make ilogb wrappers type-generic.
      Refactor FP_FAST_* into bits/fp-fast.h.
      Add build-many-glibcs.py bot-cycle action.
      Make build-many-glibcs.py support running as a bot.
      Refactor FP_ILOGB* out of bits/mathdef.h.
      Add missing hidden_def (__sigsetjmp).
      Make ldbl-128 getpayload, setpayload functions use _Float128.
      Add llogb, llogbf, llogbl.
      Fix pow (qNaN, 0) result with -lieee (bug 20919), remove dead parts of wrappers.
      Fix sysdeps/ieee754 pow handling of sNaN arguments (bug 20916).
      Fix x86_64/x86 powl handling of sNaN arguments (bug 20916).
      Fix hypot sNaN handling (bug 20940).
      Fix typo in last ChangeLog message.
      Add build-many-glibcs.py option to strip installed shared libraries.
      Fix tests-printers handling for cross compiling.
      Use Linux 4.9 (headers) in build-many-glibcs.py.
      Add [BZ #19398] marker to ChangeLog entry.
      Include <linux/falloc.h> in bits/fcntl-linux.h.
      Refactor long double information into bits/long-double.h.
      Fix generic fmax, fmin sNaN handling (bug 20947).
      Fix powerpc fmax, fmin sNaN handling (bug 20947).
      Fix x86, x86_64 fmax, fmin sNaN handling, add tests (bug 20947).
      Make build-many-glibcs.py flush stdout before execv.
      Define FE_SNANS_ALWAYS_SIGNAL.
      Document sNaN argument error handling.
      Add fmaxmag, fminmag functions.
      Add preprocessor indentation for llogb macro in tgmath.h.
      Add roundeven, roundevenf, roundevenl.
      Update miscellaneous files from upstream sources.
      Fix nss_nisplus build with mainline GCC (bug 20978).
      Update NEWS feature test macro description of TS 18661-1 support.
      Fix tst-support_record_failure-2 for run-built-tests = no.
      Define __intmax_t, __uintmax_t in bits/types.h.
      Add fromfp functions.
      Update copyright dates with scripts/update-copyrights.
      Update copyright dates not handled by scripts/update-copyrights.
      Update config.guess and config.sub to current versions.
      Make build-many-glibcs.py use binutils 2.28 branch by default.
      Correct MIPS math-tests.h condition for sNaN payload preservation.
      Fix math/test-nearbyint-except for no-exceptions configurations.
      Add build-many-glibcs.py powerpc-linux-gnu-power4 build.
      Fix MIPS n32 lseek, lseek64 (bug 21019).
      Fix elf/tst-ldconfig-X for cross testing.
      Fix math/test-fenvinline for no-exceptions configurations.
      Update i386 libm-test-ulps.
      Fix MicroBlaze __backtrace get_frame_size namespace (bug 21022).
      Make MIPS soft-fp preserve NaN payloads for NAN2008.
      Fix MicroBlaze bits/setjmp.h for C++.
      Update libm-test XFAILs for ibm128 format.
      Fix malloc/ tests for GCC 7 -Walloc-size-larger-than=.
      Fix string/tester.c for GCC 7 -Wstringop-overflow=.
      Fix MIPS n64 readahead (bug 21026).
      Increase some test timeouts.
      Make fallback fesetexceptflag always succeed (bug 21028).
      Update MicroBlaze localplt.data.
      Fix math/test-fenv for no-exceptions / no-rounding-modes configurations.
      Improve libm-test XFAILing for ibm128-libgcc.
      XFAIL libm-test.inc tests as needed for ibm128.
      Fix elf/sotruss-lib format-truncation error.
      Fix ld-address format-truncation error.
      Fix testsuite build for GCC 7 -Wformat-truncation.
      Make endian-conversion macros always return correct types (bug 16458).
      Make fallback fegetexceptflag work with generic fetestexceptflag.
      Fix MIPS o32 posix_fadvise.
      Make soft-float powerpc swapcontext restore the signal mask (bug 21045).
      Update install.texi latest GCC version known to work.
      Avoid parallel GCC install in build-many-glibcs.py.
      Fix ARM fpu_control.h for assemblers requiring VFP insn names (bug 21047).
      Restore clock_* librt exports for MicroBlaze (bug 21061).
      Update README.libm-test.
      Remove very old libm-test-ulps entries.

Maciej W. Rozycki (2):
      MIPS: Add `.insn' to ensure a text label is defined as code not data
      MIPS: Use R_MICROMIPS_JALR rather than R_MIPS_JALR in microMIPS code

Mark Wielaard (1):
      Reduce memory size of tsearch red-black tree.

Martin Galvan (3):
      Add pretty printers for the NPTL lock types
      Add -B to python invocation to avoid generating pyc files
      Fix up tabs/spaces mismatches

Martin Pitt (1):
      locales: en_CA: update d_fmt [BZ #9842]

Mike Frysinger (5):
      localedata: change M$ to Microsoft
      ChangeLog: change Winblowz to Windows
      ChangeLog: fix date
      localedata: GBK: add mapping for 0x80->Euro sign [BZ #20864]
      localedata: bs_BA: fix yesexpr/noexpr [BZ #20974]

Märt Põder (1):
      locales: et_EE: locale has wrong {p,n}_cs_precedes value [BZ #20459]

Nick Alcock (14):
      Move all tests out of the csu subdirectory
      x86_64: tst-quad1pie, tst-quad2pie: compile with -fPIE [BZ #7065]
      Configure support for --enable-stack-protector [BZ #7065]
      Initialize the stack guard earlier when linking statically [BZ #7065]
      Do not stack-protect ifunc resolvers [BZ #7065]
      Disable stack protector in early static initialization [BZ #7065]
      Compile the dynamic linker without stack protection [BZ #7065]
      Ignore __stack_chk_fail* in the rtld mapfile computation [BZ #7065]
      Work even with compilers which enable -fstack-protector by default [BZ #7065]
      PLT avoidance for __stack_chk_fail [BZ #7065]
      Link a non-libc-using test with -fno-stack-protector [BZ #7065]
      Drop explicit stack-protection of pieces of the system [BZ #7065]
      Do not stack-protect sigreturn stubs [BZ #7065]
      Enable -fstack-protector=* when requested by configure [BZ #7065]

Paul E. Murphy (28):
      Remove tacit double usage in ldbl-128
      Refactor part of math Makefile
      Unify drift between _Complex function type variants
      Improve gen-libm-test.pl LIT() application
      Support for type-generic libm function implementations libm
      ldbl-128: Remove unused sqrtl declaration in e_asinl.c
      Add tst-wcstod-round
      Prepare to convert _Complex cosine functions
      Convert _Complex cosine functions to generated code
      Merge common usage of mul_split function
      Prepare to convert _Complex sine functions
      Convert _Complex sine functions to generated code
      Prepare to convert _Complex tangent functions
      Convert _Complex tangent functions to generated code
      sparcv9: Restore fdiml@GLIBC_2.1
      Prepare to convert remaining _Complex functions
      Convert remaining complex function to generated files
      ldbl-128: Rename 'long double' to '_Float128'
      ldbl-128: Cleanup e_gammal_r.c after _Float128 rename
      Make common fdim implementation generic.
      Make common nextdown implementation generic.
      Make common fmax implementation generic.
      Make common fmin implementation generic.
      Remove unneeded stubs for k_rem_pio2l.
      ldbl-128: Use L(x) macro for long double constants
      Make ldexpF generic.
      Remove __nan{f,,l} macros
      Build s_nan* objects from a generic template

Paul Murphy (1):
      powerpc: Cleanup fenv_private.h

Rajalakshmi Srinivasaraghavan (5):
      Refactor strtod tests
      Add tests for strfrom functions
      powerpc: strcmp optimization for power9
      powerpc: strncmp optimization for power9
      powerpc64: strchr/strchrnul optimization for power8

Rasmus Villemoes (1):
      linux: spawni.c: simplify error reporting to parent

Rical Jasan (28):
      Manual typos: Input/Output on Streams
      Manual typos: Low-Level Input/Output
      Manual typos: File System Interface
      Manual typos: Sockets
      Manual typos: Low-Level Terminal Interface
      Manual typos: Syslog
      Manual typos: Mathematics
      Manual typos: Arithmetic Functions
      Manual typos: Date and Time
      Manual typos: Resource Usage and Limitation
      Manual typos: Non-Local Exits
      Manual typos: Signal Handling
      Manual typos: The Basic Program/System Interface
      Manual typos: Processes
      Manual typos: Job Control
      Manual typos: Users and Groups
      Manual typos: System Management
      Manual typos: System Configuration Parameters
      Manual typos: DES Encryption and Password Handling
      Manual typos: Debugging support
      Manual typos: POSIX Threads
      Manual typos: Internal probes
      Manual typos: C Language Facilities in the Library
      Manual typos: Installing
      Manual typos: Library Maintenance
      Manual typos: Contributors to
      manual: Remove non-existent mount options S_IMMUTABLE and S_APPEND [BZ #11235]
      manual: Convert @tables of variables to @vtables.

Richard Henderson (1):
      alpha: Use saturating arithmetic in memchr

Roland McGrath (3):
      NaCl: Fix compile error in clock function.
      Fix generic wait3 after union wait_status removal.
      NaCl: Fix compile error for __dup after libc_hidden_proto addition.

Samuel Thibault (12):
      Fix recvmsg returning SIGLOST on PF_LOCAL sockets
      mach: Add more allowed external headers
      hurd: fix pathconf visibility
      hurd: fix fcntl visibility
      Fix exc2signal.c template
      mach: Fix old-style function definition.
      Fix old-style function definition
      hurdmalloc: Run fork handler as late as possible [BZ #19431]
      hurd: Fix stack pointer corruption in syscall
      hurd: Fix unused variable warning
      hurd: fix using hurd/signal.h in C++ programs
      hurd: fix using hurd.h in C++ programs

Siddhesh Poyarekar (47):
      Consolidate reduce_and_compute code
      Add fall through comments
      Use fabs(x) instead of branching on signedness of input to sin and cos
      Consolidate input partitioning into do_cos and do_sin
      Use do_sin for sin(x) where 0.25 < |x| < 0.855469
      Inline all support functions for sin and cos
      Remove __libc_csu_irel declaration
      Add tests-static to tests in malloc/Makefile
      consolidate sign checks for slow2
      Use copysign instead of ternary conditions for positive constants
      Use copysign instead of ternary for some sin/cos input ranges
      Make the quadrant shift K a bool in do_sincos_* functions
      Check n instead of k1 to decide on sign of sin/cos result
      Manual typos: System Databases and Name Service Switch
      Make quadrant shift a boolean in reduce_and_compute in s_sin.c
      Adjust calls to do_sincos_1 and do_sincos_2 in s_sincos.c
      Update comments for some functions in s_sin.c
      Add note on MALLOC_MMAP_* environment variables
      Document the M_ARENA_* mallopt parameters
      Remove references to sbrk to grow/shrink arenas
      Remove redundant definitions of M_ARENA_* macros
      Static inline functions for mallopt helpers
      Regenerate ULPs for aarch64
      Add ChangeLog for previous commit
      Link benchset tests against libsupport
      Add configure check for python program
      Fix pretty printer tests for run-built-tests == no
      Add framework for tunables
      Initialize tunable list with the GLIBC_TUNABLES environment variable
      Enhance --enable-tunables to select tunables frontend at build time
      User manual documentation for tunables
      Add NEWS item for tunables
      tunables: Avoid getenv calls and disable glibc.malloc.check by default
      Regenerate libc.pot
      Update translations from the Translation Project
      Merge translations from the Translation Project
      Fix typo in NEWS
      Merge translations from the Translation Project
      Fix environment traversal when an envvar value is empty
      Add target to incorporate translations from translations.org
      tunables: Fix environment variable processing for setuid binaries (bz #21073)
      Drop GLIBC_TUNABLES for setxid programs when tunables is disabled (bz #21073)
      tunables: Fail tests correctly when setgid does not work
      Add missing NEWS items
      Add list of bugs fixed in 2.25
      Add more contributors to contrib.texi
      Update for 2.25 release

Stefan Liebler (22):
      Get rid of array-bounds warning in __kernel_rem_pio2[f] with gcc 6.1 -O3.
      S390: Do not set FE_INEXACT with feraiseexcept (FE_OWERFLOW|FE_UNDERFLOW).
      S390: Support PLT and GOT references in check-localplt.
      S390: Regenerate ULPs
      Add configure check to test if gcc supports attribute ifunc.
      Use gcc attribute ifunc in libc_ifunc macro instead of inline assembly due to false debuginfo.
      s390: Refactor ifunc resolvers due to false debuginfo.
      i386, x86: Use libc_ifunc macro for time, gettimeofday.
      ppc: Use libc_ifunc macro for time, gettimeofday.
      Use libc_ifunc macro for clock_* symbols in librt.
      Use libc_ifunc macro for system in libpthread.
      Use libc_ifunc macro for vfork in libpthread.
      Use libc_ifunc macro for siglongjmp, longjmp in libpthread.
      S390: Fix fp comparison not raising FE_INVALID.
      Fix new testcase elf/tst-latepthread on s390x.
      S390: Regenerate ULPs.
      S390: Use C11-like atomics instead of plain memory accesses in lock elision code.
      S390: Use own tbegin macro instead of __builtin_tbegin.
      S390: Use new __libc_tbegin_retry macro in elision-lock.c.
      S390: Optimize lock-elision by decrementing adapt_count at unlock.
      S390: Fix FAIL in test string/tst-xbzero-opt [BZ #21006]
      S390: Adjust lock elision code after review.

Steve Ellcey (14):
      Fix -Wformat-length warning in tst-setgetname.c
      Fix warning from latest GCC in tst-printf.c
      Fix -Wformat-length warning in time/tst-strptime2.c
      Define wordsize.h macros everywhere
      Speed up math/test-tgmath2.c
      Document do_test in test-skeleton.c
      Define __ASSUME_ST_INO_64_BIT on all platforms.
      Add definitions to sysdeps/tile/tilepro/bits/wordsize.h.
      Always define XSTAT_IS_XSTAT64
      Allow [f]statfs64 to alias [f]statfs
      Fix for [f]statfs64/[f]statfs aliasing patch
      Partial ILP32 support for aarch64.
      Use XSTAT_IS_XSTAT64 in generic xstat functions
      Add comments to check-c++-types.sh.

Svante Signell (1):
      hurd: Fix adjtime call with OLDDELTA == NULL

Szabolcs Nagy (1):
      Make build-many-glibcs.py work on python3.2

Tom Tromey (1):
      Update and install proc_service.h [BZ #20311]

Torvald Riegel (12):
      Add atomic_exchange_relaxed.
      Add atomic operations required by the new condition variable.
      Fix incorrect double-checked locking related to _res_hconf.initialized.
      Use C11-like atomics instead of plain memory accesses in x86 lock elision.
      Robust mutexes: Fix lost wake-up.
      New condvar implementation that provides stronger ordering guarantees.
      Fix pthread_cond_t on sparc for new condvar.
      New pthread rwlock that is more scalable.
      robust mutexes: Fix broken x86 assembly by removing it
      Clear list of acquired robust mutexes in the child process after forking.
      Add compiler barriers around modifications of the robust mutex list.
      Fix mutex pretty printer test and pretty printer output.

Tulio Magno Quites Machado Filho (9):
      powerpc: Fix POWER9 implies
      powerpc: Installed-header hygiene
      powerpc: Regenerate ULPs
      powerpc: Fix TOC stub on powerpc64 clone()
      Document a behavior of an elided pthread_rwlock_unlock
      powerpc: Fix powerpc32/power7 memchr for large input sizes
      powerpc: Fix write-after-destroy in lock elision [BZ #20822]
      powerpc: Regenerate ULPs
      powerpc: Fix adapt_count update in __lll_unlock_elision

Wilco Dijkstra (4):
      An optimized memchr was missing for AArch64.  This version is similar to
      Improve generic rawmemchr for targets that don't have an
      Improve strtok and strtok_r performance.  Instead of calling strpbrk which
      This patch cleans up the strsep implementation and improves performance.

Yury Norov (1):
      * sysdeps/unix/sysv/linux/fxstat.c: Remove useless cast.

Zack Weinberg (20):
      Add utility macros for clang detection, and deprecation with messages.
      Minimize sysdeps code involved in defining major/minor/makedev.
      Deprecate inclusion of <sys/sysmacros.h> by <sys/types.h>
      Add tests for fortification of bcopy and bzero.
      Installed-header hygiene (BZ#20366): Simple self-contained fixes.
      Installed-header hygiene (BZ#20366): obsolete BSD u_* types.
      Installed-header hygiene (BZ#20366): conditionally defined structures.
      Installed-header hygiene (BZ#20366): time.h types.
      Installed-header hygiene (BZ#20366): stack_t.
      Installed header hygiene (BZ#20366): Test of installed headers.
      Minor correction to the "installed header hygiene" patches.
      Minor corrections to scripts/check-installed-headers.sh.
      [BZ #19239] Issue deprecation warnings on macro expansion.
      Fix typo in string/bits/string2.h.
      Fix build-and-build-again bug in sunrpc tests.
      Forgot to add the ChangeLog to the previous commit, doh.
      Correct comments in string.h re strcoll_l, strxfrm_l.
      Minor problems exposed by compiling C++ tests under _ISOMAC.
      Make _REENTRANT and _THREAD_SAFE aliases for _POSIX_C_SOURCE=199506L.
      New string function explicit_bzero (from OpenBSD).

steve ellcey-CA Eng-Software (1):
      Fix warnings from latest GCC.

-----------------------------------------------------------------------